#!/bin/sh
echo "---"
echo "$0 displays defined (and undefined) externals in libs"
echo "Syntax: $0 external_name       # display defined externals"
echo "    or: $0 -u external_name    # display defined & undefined"
echo "---"

libs="/usr/lib /lib /usr/X11/lib"

prefix="T "
ext=$1
if [ "$1" = "-undef" -o "$1" = "-u" ] ; then
   prefix=""
   ext=$2
fi
if [ "$ext" = "" ] ; then 
   exit 0
fi
for l in $libs ; do
   for i in $l/lib* ; do
      x=`nm $i 2>/dev/null | grep "$prefix$ext"`
      if [ "$x" != "" ] ; then 
         echo "--- $i"
         nm $i 2>/dev/null | grep "$prefix$ext"
      fi
   done
done

# eof
          