// Compile: FlagShip codepage.prg 
//      or: Clipper  codepage.prg ; blinker fi codepage
// Run    : codepage  or  codepage -io=t

isWinConsole := .F.
#ifdef FS_WIN32
   isWinConsole := AppIoMode() == "T"
#endif

//               acute   `grave   ~tilde   ^circum  ring    Umlaut
// "437 Aa"+chr( 42,160,  42,133,  42, 42,  42,131, 143,134, 142,142) + ;
//    " Ee"+chr(144,130,  42,138,           42,136,           42,137) + ;
//    " Ii"+chr( 42,161,  42,141,           42,139,           42,139) + ;
//    " Oo"+chr( 42,162,  42,149,  42, 42,  42,147,          153,148) + ;
//    " Uu"+chr( 42,163,  42,151,           42,150,          154,129) + ;
//    " Nn"+chr(                  165,164                           )
//
// "850 Aa"+chr(181,160, 183,133, 199,198, 182,131, 143,134, 142,142) + ;
//    " Ee"+chr(144,130, 212,138,          210,136,          211,137) + ;
//    " Ii"+chr(214,161, 222,141,          215,140,          216,139) + ;
//    " Oo"+chr(224,162, 227,149, 229,228, 226,147,          153,148) + ;
//    " Uu"+chr(233,163, 235,151,          234,150,          154,129) + ;
//    " Nn"+chr(                  165,164                           )
//
// "ISO Aa"+chr(193,225, 192,224, 195,227, 194,226, 197,229, 196,228) + ;
//    " Ee"+chr(201,233, 200,242,          202,234,          203,235) + ;
//    " Ii"+chr(205,237, 204,236,          206,238,          207,239) + ;
//    " Oo"+chr(211,243, 210,242, 213,245, 212,244,          214,246) + ;
//    " Uu"+chr(218,250, 217, 42,          219,251,          220,252) + ;
//    " Nn"+chr(                  209,241                           )
//
// "*" is a filler for characters not available in specific character set

cTxt1 := "String CP437 Aa***** Ee*** Ii**** Oo***** Uu*** Nn"
cTxt2 := "String CP850 Aa Ee Ii Oo Uu Nn"
cTxt3 := "String ISO   Aa Ee Ii Oo Uu* Nn"

cTxt4 := "chr 128-191: "
for ii := 128 to 191
   cTxt4 += chr(ii)
next
cTxt5 := "chr 192-254: "
for ii := 192 to 254
   cTxt5 += chr(ii)
next

#ifndef FlagShip
// -- Clipper, no variants possible --
? cTxt1
? cTxt2
? cTxt3
? cTxt4
? cTxt5

#else
// --- FlagShip, with different variants ---
// set guicolor on
set font "courier"

? "--------------- default CP437" color "R+" guicolor "B"
if isWinConsole  // MS-Windows Terminal i/o mode ?
   /* MS-Windows Console note: you will probably need
    *   to set window property -> font to Lucida Console
    *   to proper display both codepage 437 and 850
    */
   ? "switching to CP mode 437 ..." color "GR+"
   run("MODE CON CP select=437")
endif
? cTxt1
? cTxt2
? cTxt3
? cTxt4
? cTxt5

? "--------------- SET SOURCE ASCII with CP437 " color "R+" guicolor "R+"
SET SOURCE ASCII
? cTxt1
? cTxt2
? cTxt4
? cTxt5

? "--------------- and SET GUITRANSL TEXT ON" color "R+" guicolor "R+"
SET GUITRANSL TEXT ON
? cTxt1
? cTxt2
? cTxt4
? cTxt5
if maxrow() < 29
  ?
  wait
  setpos(row() -2,0)
endif
// ? "hallo 3" guicolor "#071cff"
// ? "hallo 4" guicolor "#0011cc"
// ? "hallo 5" guicolor "#0012e0"
// ? "hallo 4" guicolor "#081adb"

? "--------------- SET SOURCE ASCII with CP850" color "R+" guicolor "#0012e0"
if isWinConsole
   ? "switching to CP mode 850 ..." color "GR+"
   run("MODE CON CP select=850")
else
   SET GUITRANSL TEXT OFF
   FS_SET("ansi2oem","FSansi2oem.cp850")
   if empty(FS_SET("ansi2oem"))
      alert("cannot open or not found file;FSansi2oem.cp850")
   endif
endif
? cTxt1
? cTxt2
? cTxt4
? cTxt5

? "--------------- and SET GUITRANSL TEXT ON" color "R+" guicolor "B+"
SET GUITRANSL TEXT ON
? cTxt1
? cTxt2
? cTxt4
? cTxt5

#endif  /* Clipper/FlagShip */
?
wait

