* Example of using arrays, dates and input/output by @..GET / READ
* including field validation and changing GET fields
* 
* Copyright (c) 2002..06 by multisoft GmbH, Munich, Germany 
* You may freely modify this source according to your needs and/or
* re-use any parts of it in your source code.
* Release $Date: 2006/06/23 13:50:18 $
*--------------------------------------------------------------------------
// Compile: FlagShip getread2.prg -o getread2     # compile for hybrid mode
// Execute: getread2  (or ./getread2)             # GUI mode (auto detect)
//      or: getread2 -io=t                        # Terminal mode
//      or: newfswin ./getread2                   # Unix/Linux Terminal mode 
//
// -> see also: getread[1-4].prg, keyboard.prg, umlauts.prg
// ->    fsman: FSC, CMD, REL, LNG.9

#include "fspreset.fh"        // see <FlagShip_dir>/include directory

local   cName, cAddress, cCity, nZip, nNum, lMale, dDate, dBirth
private aAnyData := array(3)         // cannot be local, used by macro in VALID
private nDateRow := 0, nDateCol := 0 // used also in AlternDate()
local   ii, cFont, nRow, ok := .T.

cName := cAddress := space(40)
cCity := space(30)
nZip  := nNum := 0
lMale := .T.
dDate := date()               // today's date
dBirth:= ctod("")             // empty date
AFILL(aAnyData, space(40))    // set all array elements to 40 spaces

SET CENTURY ON                // display year of date with 4 digits 
// SET DATE GERMAN            // specify your date format, or alternates it:
// set font "courier"         // enable for fixed fonts in GUI

@ 1,0 SAY "Enter your data or exit by ESC, F2 changes date format" ;
      COLOR "R+" GUICOLOR "R+"
SET KEY K_F2 TO AlternDate

while ok
// AlternDate()            // alternate the date format
   
   @ 3,0 SAY  "Your name " GET cName VALID myCheck(cName)
   @ 4,0 SAY  "Address   " GET cAddress
   @ 5,0 SAY  "Zip, City " GET nZip PICTURE "999999" ;
                              RANGE 1000,999998 VALID !empty(nZip)
   @ 5,col()+4             GET cCity VALID myCheck(cCity)
   @ 6,0 SAY  "Male      " GET lMale PICTURE "Y"
   @ row(), col()+2 SAY "(Y, N, T=Y, F=N)"
   @ 7,0 SAY  "Birth date" GET dBirth PICTURE "@D"
   nDateRow := row()       // used also in AlternDate()
   nDateCol := col() +2
   @ nDateRow, nDateCol SAY "(" + set(_SET_DATEFORMAT) + " format)"
   for ii := 1 to len(aAnyData)
      @ ii+7, 0 SAY "Any Data " + ltrim(ii) GET aAnyData[ii] ;
          VALID (if(ReadVar() == "AANYDATA[2]", myCheck(&(ReadVar())), .T.))
   next

   READ                    // process data input, see ../system/getread.prg 

   if lastKey() == K_ESC   // ESC pressed?
      ok := .F.            // yes, terminate the endless loop
   endif

   nRow  := 11
   if AppIoMode() == "G"         // GUI mode?
      nRow  := row2pixel(nRow)   // save the curr. row in pixel
      cFont := set(_SET_FONTNAME, "courier") // set fixed font
      nRow  := pixel2row(nRow)   // get the row number for changed font
   endif
   
   @ ++nRow,0 say "--- Variable content after READ ---" COLOR "R+" GUICOLOR "R+"
   @ ++nRow,2 SAY "cName       = '" + cName + "'"
   @ ++nRow,2 SAY "cAddress    = '" + cAddress + "'"
   @ ++nRow,2 SAY "nZip        = " + ltrim(nZip)
   @ ++nRow,2 SAY "cCity       = '" + cCity  + "'"
   @ ++nRow,2 SAY "lMale       = " + if(lMale, ".T.", ".F.")
   @ ++nRow,2 SAY "dBirth      = " + dtoc(dBirth) 
   for ii := 1 to len(aAnyData)
      @ ++nRow, 2 SAY "aAnyData[" + ltrim(ii) + "] = '" + aAnyData[ii] + "'"
   next
   set(_SET_FONTNAME, cFont)     // restore previous font
enddo

setpos(maxrow() -1, 0)
wait "Done, press any key to exit..."
quit

/* ----------------------------------------------------------
 * validator for not empty value, invoked in @..GET/READ
 */
FUNCTION myCheck(val)
if !empty(val)       // is value not empty?
   return .T.        // ok
endif
alert("This entry field may not be empty")
return .F.           // signal failure

/* ----------------------------------------------------------
 * Alternate the date format
 * executed by F2 key (or called directly w/o parameter)
 * uses private variables from main
 */
FUNCTION AlternDate(cProc,iLine,cReadvar)
MEMVAR nDateRow, nDateCol
local ii, iPos, oGet, cDateForm
local aDateForm := {{"mm/dd/yyyy","99/99/9999"}, ; // default, SET DATE AMERICAN 
                    {"mm-dd-yyyy","99-99-9999"}, ; // SET DATE USA
                    {"dd.mm.yyyy","99.99.9999"}, ; // SET DATE GERMAN
                    {"dd/mm/yyyy","99/99/9999"}, ; // SET DATE BRITISH
                    {"dd-mm-yyyy","99-99-9999"}, ; // SET DATE ITALIAN
                    {"yyyy/mm/dd","9999/99/99"}, ; // SET DATE JAPAN
                    {"yyyy.mm.dd","9999.99.99"} }  // SET DATE ANSI
static iDatePos := 0

iDatePos++                          // increase array index 
if iDatePos > len(aDateForm)        // if array index > array size,
   iDatePos := 1                    // re-start from 1st element
endif
cDateForm := aDateForm[iDatePos,1]     
SET DATE FORMAT TO (cDateForm)      // use alternate date format

if empty(cReadvar)                  // invoked outside of READ,
   return                           // cannot re-display yet
endif

@ nDateRow, nDateCol                // clear rest of line
@ nDateRow, nDateCol SAY "(" + cDateForm + " format)"

for ii := 1 to len(getlist)         // array holding GET objects
   oGet := getlist[ii]               
   if upper(oGet:Name) == "DBIRTH"
//    oGet:Picture := "@D " + aDateForm[iDatePos,2]
      oGet:Display(.T.)             // re-display GET field
      exit                          // exit the for loop
   endif
next
return
      
* eof *
