/* For FlagShip 5 and 6
 * Copyright (c) 2004..07 by multisoft GmbH, Munich, Germany
 *
 * You may freely modify this source according to your needs and/or
 * re-use any parts of it in your source code.
 * Release $Date: 2007/08/17 08:44:49 $
 *--------------------------------------------------------------------------
 * This application demonstrates use of GET field replacement
 * via SET KEY or WHEN or VALID. See also getvalid1.prg
 *
 * Copy the source to your working directory, and
 *
 * Compile Linux  : FlagShip getvalid2.prg -o getvalid2
 *          run   : ./getvalid2
 *           or   : newfswin ./getvalid2
 *           or   : ./getvalid2 -io=t
 * Compile Windows: FlagShip getvalid2.prg
 *          run   : getvalid2
 *           or   : getvalid2 -io=t
 */

declare aFields[5]
afill(aFields, space(20))

local ii
set key K_F2 to f2fun
? "F2 key changes the 1st and last field,"
? "3rd field is changed at entering, 4th on exit if empty"

for ii := 1 to len(aFields)
   @ ii +4,1 say "Field " + ltrim(ii)
   do case
   case ii == 3
      @ row(), col() +1 GET aFields[ii] WHEN fld34fun()
   case ii == 4
      @ row(), col() +1 GET aFields[ii] VALID fld34fun(.T.)
   otherwise
      @ row(), col() +1 GET aFields[ii]
   endcase
next
read
for ii := 1 to len(aFields)
   @ ii+4,40 say aFields[ii]
next
wait
quit

/* -------------------------------------------------------------------
 * function entered via F2 key
 * changes some fields (here first and last) and
 * perform refresh of all GETs to make changes visible
 */
function f2fun
   local ii
   local oGet := GetActive()

   // change the external data
   aFields[1] := padr( time(1), len(aFields[1]) )
   aFields[len(aFields)] := padr( time(1), len(aFields[len(aFields)]) )

   // here: refresh all GET fields
   for ii := 1 to len(getlist)
      getlist[ii]:SetFocus()
      getlist[ii]:UpdateBuffer()    // requires focus
      getlist[ii]:KillFocus()
   next
   // re-set focus to curent field
   oGet:SetFocus()
   return .t.

/* -------------------------------------------------------------------
 * function entered via WHEN (or VALID with .T.) clause
 * changes current GET field and refresh it
 */
function fld34fun(par)
   local oGet := GetActive()
   local cValue := oGet:Varget()
   if valtype(par) == "L" .and. par .and. empty(cValue)
      oGet:Varput( padr(time(1), len(cValue)) )
   elseif valtype(par) != "L" .or. !par
      oGet:Varput( padr(time(1), len(cValue)) )
   endif
   return .t.

/* eof */
