/* For FlagShip 5 and 6
 * Copyright (c) 2003..05 by multisoft GmbH, Munich, Germany 
 *
 * You may freely modify this source according to your needs and/or
 * re-use any parts of it in your source code.
 * Release $Date: 2005/11/23 13:17:59 $
 *--------------------------------------------------------------------------
 * This application demonstrates use of MDI application
 *
 * Copy the source to your working directory, and
 * Compile: FlagShip -w -m -mdi [-io=g] mdi.prg -o mdi
 * Run    : ./mdi [-io=g]
 *
 * MS-Windows: FlagShip -w -m -mdi [-io-g] mdi.prg 
 * Run:        mdi 
 */

@ 1,0 say "MDI example" color "R+" GUICOLOR "R+"

if !AppMdiMode()
   if AppIoMode() == "G"
      ? "Please compile with -mdi switch and re-start"
      wait
      quit
   else
      ? "MDI mode is possible in GUI only."
      ? "If you own FS2 Tools, use Wopen() instead, which"
      ? "support windowing in all available i/o modes."
      wait "Press any key to continue or ESC to abort..."
      if lastkey() == K_ESC
         quit
      endif
   endif
endif

?
? "This is the main screen, accessed by MdiSelect(0)"
?
? "We will now open two additional screens:"
? "  - Window#2 at coordinates  5,10,20,50 and" 
? "  - Window#3 at coordinates 10,30,18,70"
wait

// create Window#2 and display data there
nWin2 := MdiOpen(5,10,20,50,"Window#2")
rr := MaxRow()
cc := MaxCol()
? "writing now to Window#2 with MaxRow()=" + ltrim(rr) + ;
  " and MaxCol()="+ltrim(cc)

// create Window#3 and display data there
nWin3 := MdiOpen(10,30,18,70,"Window#3")
rr := MaxRow()
cc := MaxCol()
? "writing now to Window#3 with MaxRow()=" + ltrim(rr) + ;
  " and MaxCol()="+ltrim(cc)
? "where this 'Window#3' with ID",ltrim(nWin3),"has input focus now."
wait "press any key to select Window#2.."

// select and work in Window#2 
MdiSelect(nWin2)
? "This 'Window#2' with ID",ltrim(nWin2),"has input focus now."
? "It is accessed by 'MdiSelect(" + ltrim(nWin2) + ")' or better 'MdiSelect(nWin2)'"
? "You may use any i/o operations here, will use Tbrowse() now"
wait
cls
? "exit Tbrowse by ESC"
local aRecords := {{"one",1},{"two",2},{"three",3},{"four",4},{"five",5}}
local aHeader  := {"fld#1","   field#2"}
local oBr := TbrowseArr(3,5, 6,30, NIL, NIL, "My Browse") 
oBr:CanAppend := .F.    
oBr:UserArray := aRecords        
for ii := 1 to len(aRecords[1])
   oTbcol := TbColumnNew(aHeader[ii], .T.)   // use default array block
   oBr:AddColumn(oTbcol)
next
oBr:Exec()                   // calls UDF assigned by :Handler
@ 8,0 say "Tbrowse done"
wait "Press any key to switch to Window#3 ..."

// select and work in Window#3 
MdiSelect(nWin3)
? "Continuing output in 'Window#3'"
? "You may resize the windows by mouse (right mottom edge) and"
? "re-arrange them also via Menu->Windows"
wait "Will close 'Window#2' now ..."

// close Window#2 
MdiClose(nWin2)
wait "Will close this 'Window#3' now ..."

// close Window#3 
MdiClose()

? "continuing output in Window#0"
wait "done ..."

