* This example demonstrates different use and features of FlagShip 5 and 6
* CheckBox, RadioButton and RadioGroup
* Release $Date: 2005/11/25 19:58:37 $
*
* Note: Only a part of this source will run with Clipper 5.3, since the most 
* features are missing there; see the "compatibility" notes in the manual
*
* Compile: FlagShip radiocheckbox.prg [-io-a|g|t|b] -o radiocheckbox
* Run:     ./radiocheckbox [-io=g|t|b]
*
* MS-Windows: FlagShip radiocheckbox.prg [-io-a|g|t|b]
* Run:        radiocheckbox  -or-  radiocheckbox -io=t

#include "box.fh"
#include "boxclass.fh"
#include "inkey.fh"

** -----------------------------------------------------------------------------
** Note: following constants are set at applic startup-time (in initio.prg).
** You may override the values now (i.e. un-comment) if you want to change
** the automatic look-and-feel correction to the terminal based application
**
* _aGlobSetting[GSET_G_L_LISTBOX_ADJ ] := .T.        // use ListBox,Achoice() row/col adjustment?
* _aGlobSetting[GSET_G_L_LISTBOX_BOX ] := .T.        // adjust ListBox row/col for not empty frame
* _aGlobSetting[GSET_G_L_MEMOEDIT_ADJ] := .T.        // use MemoEdit() row/col adjustment?
* _aGlobSetting[GSET_G_N_LISTBOX_TOP ] := -2         // adjust pix ListBox,Achoice(),MemoEdit() top 
* _aGlobSetting[GSET_G_N_LISTBOX_BOT ] := 2          // adjust pix ListBox,Achoice(),MemoEdit() bottom
* _aGlobSetting[GSET_G_N_LISTBOX_LEFT] := -7         // adjust pix ListBox,Achoice(),MemoEdit() left
* _aGlobSetting[GSET_G_N_LISTBOX_RIGH] := 6          // adjust pix ListBox,Achoice(),MemoEdit() right
* _aGlobSetting[GSET_G_N_COMBO_HEIGHT] := 4          // add pix to closed combo line height
* 
* _aGlobSetting[GSET_G_L_CHBOX_ADJ   ] := .T.        // use CheckBox row/col adjustment?  
* _aGlobSetting[GSET_G_N_CHBOX_COL   ] := 2          // adjust pix left column of CheckBox 
* _aGlobSetting[GSET_G_N_CHBOX_ROW   ] := -3         // adjust pix upper row of CheckBox 
* _aGlobSetting[GSET_G_N_CHBOX_WIDTH ] := 20         // add pix CheckBox width
* _aGlobSetting[GSET_G_N_CHBOX_HEIGHT] := 0          // adjust pix height of RadioButton 
* _aGlobSetting[GSET_G_N_CHBOX_CAPCOL] := 10         // CapCol caption pix dist. if auto
* _aGlobSetting[GSET_G_L_CHBOX_STYLE ] := .F.        // consider :Style = add 1 column if :Style is set
*  
* _aGlobSetting[GSET_G_L_RADBUT_ADJ  ] := .T.        // use RadioButton row/col adjustment?  
* _aGlobSetting[GSET_G_N_RADBUT_COL  ] := 2          // adjust pix left column of RadioButton
* _aGlobSetting[GSET_G_N_RADBUT_ROW  ] := -3         // adjust pix upper row of RadioButton 
* _aGlobSetting[GSET_G_N_RADBUT_WIDTH] := 20         // add pix RadioButton width 
* _aGlobSetting[GSET_G_N_RADBUT_HEIGHT]:= 0          // adjust pix RadioButton height 
* _aGlobSetting[GSET_G_N_RADBUT_CAPCOL]:= 10         // CapCol caption pix dist. if auto
* _aGlobSetting[GSET_G_L_RADBUT_STYLE] := .F.        // consider :Style = add 1 column if :Style is set
* 
* _aGlobSetting[GSET_G_L_RADGRP_ADJ  ] := .T.        // use RadioGroup row/col adjustment?  
* _aGlobSetting[GSET_G_N_RADGRP_TOP  ] := 0          // adjust pix RadioGroup top 
* _aGlobSetting[GSET_G_N_RADGRP_BOT  ] := 0          // adjust pix RadioGroup bottom 
* _aGlobSetting[GSET_G_N_RADGRP_LEFT ] := 0          // adjust pix RadioGroup left 
* _aGlobSetting[GSET_G_N_RADGRP_RIGH ] := 0          // adjust pix RadioGroup right 
* _aGlobSetting[GSET_G_N_RADGRP_ADCOL] := 10         // adjust pix RadioGroup frame left/right if auto
* _aGlobSetting[GSET_G_N_RADGRP_ADROW] := 10         // adjust pix RadioGroup frame top/bottom if auto
** -----------------------------------------------------------------------------

/* enable/disable the define's for tests you want
 */
#define WITH_DOTS
#define CHECKBOXES
#define RADIOBUTTONS
#define RADIOGROUPS
// #define REPORT_FOCUS
// #define REPORT_STATUS

local cIoType := AppIoMode()  as char      // = "G","T","B"
local sScreen                 as usual
local ii,jj                   as intvar
local oCbox1, oCbox2, oCbox3,oCbox4, oRadio as object
local aRadio := {}            as array

private globObj

#define ROW_FOC  20
#define ROW_STAT 21

// FS_SET("Devel", .T.)    // enable developer's warnings

/* Note: Colors are ignored in GUI, unless
 * SET GUICOLOR ON is set
 */
set color to "W+/B,R+/B,W/B,W/B,GR+/B"   
cls

#ifdef WITH_DOTS
for ii := 0 to 15
   for jj := 0 to 50
      @ ii, jj say if((jj % 10) == 0, ":", ".") color "G/B"
      @ ii,0 say ltrim(ii) color "G/B"
   next
next
#endif
sScreen := SaveScreen(0,0,20,maxcol())

SET MESSAGE TO 15 CENTER

// --- single check boxes ---
#ifdef CHECKBOXES
@ 1,10 say "Single CheckBoxes " color ("GR+/B")
if AppIoMode() == "G"   // GUI?
   ?? "- using font", oApplic:Font:FontFamily + "," + ltrim(oApplic:Font:SizePixel()) 
endif
oCbox1 := CheckBox(3,10,"First box")
oCbox1:Message := "Box1: Exit = Ret,Esc,Cursor - Check = space,y,n,t,f"
oCbox1:Display()

oCbox2 := CheckBox{5,10}      // (...) are supported as well
oCbox2:Caption := "Second box"
oCbox2:Message := "Box2: Exit = Ret,Esc,Cursor - Check = space,y,n,t,f"
oCbox2:Sblock  := {|oBox,lStat| RepStatus(oBox,lStat) }
oCbox2:ColorSpec := "-/-,G+/B,-/-,-/-,GB+/-"
oCbox2:Display()

oCbox3 := CheckBox(7,NIL,"Box 3","Three")
oCbox3:Col     := 10
oCbox3:CapCol  := oCbox3:Col - len(oCbox3:Caption) - 1
oCbox3:ColdBox := B_PLAIN
oCbox3:HotBox  := B_PLAIN
oCbox3:Style   := ""
// oCbox3:ColorSpec := "W+/B,R+/B,GR+/B,R/B"
oCbox3:Select(.T.)
oCbox3:Fblock  := {|oBox,lStat| RepFocus (oBox,lStat) }
oCbox3:Sblock  := {|oBox,lStat| RepStatus(oBox,lStat) }
oCbox3:ToolTip := "CheckBox 3, object info via F2"
oCbox3:Message := "Box3: Exit= Ret,Esc,Cursor - Check= space,y,n,t,f - Info= F2"
oCbox3:Display()

oCbox4 := CheckBox(11,10,"Box 4")
oCbox4:CapCol  := oCbox4:Col - StrLen2Col(oCbox3:Caption) - 1
oCbox4:Style   := ""
oCBox4:Data    := "Four"
// oCbox4:ColorSpec := "W+/B,R+/B,GR+/B,R/B"
oCbox4:Select(.T.)
oCbox4:Fblock  := {|oBox,lStat| RepFocus (oBox,lStat) }
oCbox4:Sblock  := {|oBox,lStat| RepStatus(oBox,lStat) }
oCbox4:Font    := Font{"Courier",20}
oCbox4:ToolTip := "CheckBox 4, font = Courier,10"
oCbox4:Message := "Box4: Exit= Ret,Esc,Cursor - Check= space,y,n,t,f - Info= F2"
oCbox4:Display()

while .T.
   @ ROW_FOC,0 clear to ROW_STAT,maxcol()
   @ 20,0 say "There is no keyboard handler here for support Up/Down etc."
   @ 21,0 say "The check boxes are processed sequentially."
   @ 22,0 say "For a better sequence controll, you may use @..GET/READ"
   
   oCbox1:Show()  // process input via std. handler, see checkboxhand.prg
   oCbox2:Show()  
   set key K_F2 to objInfo()
   globObj := oCbox3
   oCbox3:Show()  
   globObj := oCbox4
   oCbox4:Show()  
   set key K_F2 to
   
   @ 16,0 say " Repeat (y/n/q) ? " 
   key := inkey(0)
   if key <= 255 .and. chr(key) $ "Qq"
      quit
   endif
   if !(chr(key) $ "Yy") .or. key == K_ESC
      exit
   endif
enddo
#endif  
   
// --- single radio buttons ---

#ifdef RADIOBUTTONS
set color to "W+/B,R+/B,W/B,W/B,GR+/B"   // apply for terminal only
RestScreen(0,0,20,maxcol(),sScreen)
@ 1,10 say "Single Radio Buttons " color ("GR+/B")

aadd(aRadio, RadioButton{3,10,"First button"} )
aRadio[1]:Message := "Butt1: Exit = Ret,Esc,Cursor - Check = space,y,n,t,f"
aRadio[1]:Display()

aadd(aRadio, RadioButton{5,10} )
aRadio[2]:Caption := "Second button"
aRadio[2]:Message := "Butt2: Exit = Ret,Esc,Cursor - Check = space,y,n,t,f"
aRadio[2]:Sblock  := {|oBox,lStat| RepStatus(oBox,lStat) }
aRadio[2]:Display()

oRadio := RadioButton{7,10,"Button 3","Three"}
oRadio:CapCol  := oRadio:Col - len(oRadio:Caption) - 1
oRadio:ColdBox := B_PLAIN
oRadio:HotBox  := B_PLAIN
//oRadio:ColorSpec := "W+/B,R+/B,GR+/B,R/B"
oRadio:Select(.T.)
oRadio:Fblock  := {|oBox,lStat| RepFocus (oBox,lStat) }
oRadio:Sblock  := {|oBox,lStat| RepStatus(oBox,lStat) }
oRadio:ToolTip := "RadioButt 3, object info via F2"
oRadio:Message := "Butt3: Exit= Ret,Esc,Cursor - Check= space,y,n,t,f - Info= F2"
oRadio:Display()
aadd(aRadio, oRadio)

aadd(aRadio, RadioButton{9,10,"Button 4"} )
oRadio := aRadio[len(aRadio)]
oRadio:CapCol  := oRadio:Col - StrLen2Col(oRadio:Caption) - 1
oRadio:Data    := "Four"
//oRadio:ColorSpec := "W+/B,GR+/B,W/B,GR+/B"
oRadio:Select(.T.)
oRadio:Fblock  := {|oBox,lStat| RepFocus (oBox,lStat) }
oRadio:Sblock  := {|oBox,lStat| RepStatus(oBox,lStat) }
oRadio:ToolTip := "RadioButt 4, column pos differs to Box 3 in GUI"
oRadio:Message := "Butt4: Exit= Ret,Esc,Cursor - Check= space,y,n,t,f - Info= F2"
oRadio:Display()

while .T.
   @ ROW_FOC,0 clear to ROW_STAT,maxcol()
   @ 20,0 say "There is no keyboard handler here for support Up/Down etc."
   @ 21,0 say "The radio buttons are processed sequentially."
   @ 22,0 say "For a better sequence controll, you may use @..GET/READ"

   set key K_F2 to objInfo()
   for ii := 1 to len(aRadio)
      globObj := aRadio[ii]
      aRadio[ii]:Show()    // process via std. handler, see radbutthand.prg
   next
   set key K_F2 to
   
   @ 16,0 say " Repeat (y/n/q) ? " 
   key := inkey(0)
   if key <= 255 .and. chr(key) $ "Qq"
      quit
   endif
   if !(chr(key) $ "Yy") .or. key == K_ESC
      exit
   endif
enddo
#endif

// --- radio group  ---
#ifdef RADIOGROUPS

aRadio := {}

RestScreen(0,0,20,maxcol(),sScreen)

@ 1,10 say "Radio Groups " color ("GR+/B")

oGroup1 := RadioGroup(2,10,6,31)
oGroup1:AddItem(RadioButton{3,12,"First button"} )
oGroup1:AddItem(RadioButton{4,12,"Second button"} )
oGroup1:AddItem(RadioButton{5,12,"Third button"} )
oGroup1:Message := "Message of RadioGroup#1"
oGroup1:Caption := "Group 1"
oGroup1:CapRow  := 2
oGroup1:CapCol  := oGroup1:Left - StrLen2Col(oGroup1:Caption) - 1
oGroup1:Display()

aadd(aRadio, RadioButton{-1,-2,"First button"} )
aadd(aRadio, RadioButton{-2,-2,"Disabled button"} )
aRadio[len(aRadio)]:Enabled   := .F.
aRadio[len(aRadio)]:ColorSpec := "-/-,-/-,-/-,-/-,-/-,-/-,-/-,R/B"
aadd(aRadio, RadioButton{-3,-2,"Third button"} )
oGroup2 := RadioGroup(9,10)
for ii := 1 to len(aRadio)
   aRadio[ii]:Message := "Message of RadioButton#" + ltrim(ii)
   oGroup2:AddItem(aRadio[ii])
next
if AppIoMode() == "G"
   oGroup2:Tooltip := "Auto: Right/Bottom coord and Buttons auto-calculated"
else
   oGroup2:Message := "Auto: Right/Bottom coord and Buttons auto-calculated"
endif
oGroup2:CapRow  := 8
oGroup2:CapCol  := 10
oGroup2:ColdBox := B_PLAIN
oGroup2:Display()

while .T.
   @ 20,0 say "There is no keyboard handler here for support Up/Down etc."
   set key K_F2 to objInfo()
   globObj := oGroup1   // required only for objInfo() and focus msg
   oGroup1:Show()       // process via std. handler, see radgrouphand.prg
   globObj := oGroup2   
   oGroup2:Show()  
   set key K_F2 to

   @ 16,0 say " Repeat (y/n/q) ? " 
   key := inkey(0)
   if key <= 255 .and. chr(key) $ "Qq"
      quit
   endif
   if !(chr(key) $ "Yy") .or. key == K_ESC
      exit
   endif
   @ 16,0
enddo
#endif
      
wait
quit

FUNCTION RepFocus(obj, status)
#ifdef REPORT_FOCUS
   local x := col(), y := row()  as numer
   @ ROW_FOC,0 clear 
   @ ROW_FOC,0 say "Focus: status=" 
   ?? status
   if obj:Data != NIL
      ?? " Data=",obj:data
   endif
   ?? " called from:", ProcStack(1)    
   devpos(y,x)
#endif
   return NIL

FUNCTION RepStatus(obj, status)
#ifdef REPORT_STATUS
   local x := col(), y := row()  as numer
   @ ROW_STAT,0 clear 
   @ ROW_STAT,0 say "Select: status=" 
   ?? status
   if obj:Data != NIL
      ?? " Data=",obj:data
   endif
   ?? " called from:", ProcStack(1)    
   devpos(y,x)
#endif
   return NIL

FUNCTION objInfo()
   set print on
   set console off
   ? "Object info at", ProcStack(1)    
   _DisplObj(globObj)                  
   set console on
   set print off
   @ globObj:Row, 50 say "Object data printed to " + fs_set("print")
   return NIL

* eof

