#ifdef COMMENT_ONLY
/* For FlagShip 5 
 * Copyright (c) 2001 by multisoft GmbH, Munich, Germany 
 *
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2005/11/11 14:15:05 $
 */
#endif

static char *fileID="@@#asciRdd:Init() $Revision: 1.4 $";

#include "asgener.h"
/*--------------------------------------------------------------------------*
 | Open asci file as Delimited or SDF                                       |
 |                                                                          |
 | Paramaters:                                                              |
 | 0 - ovSelf                                                               |
 | 1 - cFileName                                                            |
 | 2 - aStructure                                                           |
 | 3 - cDelimiter (optional) default = BLANK                                |
 | 4 - bFor       (optional)                                                |
 | 5 - bWhile     (optional)                                                |
 | 6 - iNext      (optional)                                                |
 | 7 - iRecord    (optional)                                                |
 | 8 - lNewArea   (optional) default = .t.                                  |
 |                                                                          |
 | Returns: ovSelf, success is signalled via NetErr() and ::used            |
 *--------------------------------------------------------------------------*/
AsMethod(init)
{
	FSint     ii;
	FSint     iTmp;
	FSvar   * vTmp1;
	FSvar   * vTmp2;
	
	AsMethodObjPtr(pxSelf);
	
	pxSelf = (xAsciRdd *) Mmalloc(sizeof(xAsciRdd), fgs_errmsg[32],
								  ERRTYP_FTL, RP_ALWAYS);
	
	SET_VAR_SPECIAL(VAR_OBJ(argv[0], AscirddReservedHidden),(FSvoid *)pxSelf);
	
	asClearObject(argv[0]);
	
	if(ISNILARG(1)) 
	{
		AsDbStatus(pxSelf) = DBF_CLOSED;
		goto error_out;
	}
	
    if(!ISCHRARG(1))
    {
        rt_error(RTILLTYP, "open asci-file name");
        goto error_out;
    }
    
	if(ISNILARG(2) || !ISARRARG(2)) goto error_out;
	
	AsFCount(pxSelf) = VAR_ISDIM(vTmp1 = argv[2]);
	
	AsFldDefs(pxSelf) = (xFldDef *)
	                    Mmalloc((long) AsFCount(pxSelf) * sizeof(xFldDef),
								fgs_errmsg[15], ERRTYP_FTL, RP_ALWAYS);
	
	for(ii = 0; ii < (FSint) AsFCount(pxSelf); ii++)
	{
   		vTmp2 = VAR_ARRELEM(vTmp1, ii + 1);
		
		if(   (!IS_VAR_ARR(vTmp2))
		   || (!IS_VAR_CHR(VAR_ARRELEM(vTmp2, 1)))
		   || (!IS_VAR_CHR(VAR_ARRELEM(vTmp2, 2)))
		   || (!IS_VAR_NUM(VAR_ARRELEM(vTmp2, 3)))
		   || (!IS_VAR_NUM(VAR_ARRELEM(vTmp2, 4))))
		{
		    rt_error(RTARGTYP, "AsciRdd: wrong structure definition");
			goto error_out;
        }
		
		trim(fgs2Upper((FSchar *) VAR_CHR(VAR_ARRELEM(vTmp2, 1))));
		trim(fgs2Upper((FSchar *) VAR_CHR(VAR_ARRELEM(vTmp2, 2))));
		
		iTmp = fgsIntVar(VAR_ARRELEM(vTmp2,3));
		
		if(((int) strlen((FSchar *) VAR_CHR(VAR_ARRELEM(vTmp2,2))) < 1)
		   || ((int) strlen((FSchar *) VAR_CHR(VAR_ARRELEM(vTmp2,1))) > 10)
		   || (iTmp <= 0))
		{
		    rt_error(RTARGVAL, "AsciRdd: structure contents in error");
			goto error_out;
		}
		
		if(iTmp < 256)
		{
			AsFLen(pxSelf, ii)  = (FSuchar) iTmp;
			AsFDec(pxSelf, ii)  = (FSuchar) fgsIntVar(VAR_ARRELEM(vTmp2, 4));
		}
		else
		{
			AsFLen(pxSelf, ii)  = (FSuchar) (iTmp % 256);
			AsFDec(pxSelf, ii)  = (FSuchar) (iTmp / 256);
		}
		
		AsFType(pxSelf, ii) = VAR_CHR(VAR_ARRELEM(vTmp2, 2))[0];
		
        switch(iTmp = AsFType(pxSelf, ii))
		{
		case 'C':
			iTmp = AsFLen(pxSelf, ii) +  (AsFDec(pxSelf, ii) * 256);
			
			if(iTmp > 65535)
			{
				rt_error(RTILLVAL,"character field exceeds 64Kb");
				goto error_out;
			}
			
			AsRecSize(pxSelf)   += (FSushort) iTmp;
			break;
			
        case 'F':
		case 'N':
			if((AsFLen(pxSelf, ii) > 20) || (AsFDec(pxSelf, ii) > 18))
			{
				rt_error(RTILLVAL,"numeric field size exceeds 20 chars");
				goto error_out;
			}
			
			AsRecSize(pxSelf) += AsFLen(pxSelf, ii);
			break;
			
		case 'L':
			AsRecSize(pxSelf) += 1;
			AsFLen(pxSelf, ii) = 1;
			break;
			
		case 'D':
			AsRecSize(pxSelf) += 8;
			AsFLen(pxSelf, ii) = 8;
			break;
			
		default:
			sprintf(repdum, "unknown field type '%c'", iTmp);
			rt_error(RTILLTYP,repdum);
			goto error_out;
        }    
		
		if(AsRecSize(pxSelf) > 65534) // FS615: was 65535
		{
			rt_error(RTILLVAL, "record size exceeds 64Kb");
			goto error_out;
		}
		
		strncpy(AsFName(pxSelf, ii),
				(FSchar *) VAR_CHR(VAR_ARRELEM(vTmp2, 1)), 10);
		AsFName(pxSelf, ii)[10] = 0;
	}
	
    fgsAddExtension(AsFileSpec(pxSelf),
					(FSchar *) VAR_CHR(argv[1]), ".txt", 250);
    
	if(!(AsFh(pxSelf) = fopen_fil(AsFileSpec(pxSelf), "r"))) goto error_out;
    
	if(!ISNILARG(3) && ISCHRARG(3))
	{
		switch (VAR_CHR(argv[3])[0])
		{
		case 0  : AsDelimiter(pxSelf)[1] = 0;     break;/* SDF               */
		case '"': AsDelimiter(pxSelf)[0] = '"';   break;/* "xxx", nnn," xxx" */
		case ' ': AsDelimiter(pxSelf)[0] = 0;
                  AsDelimiter(pxSelf)[1] = 0;     break;/* xxx nnn xxx       */
		default : AsDelimiter(pxSelf)[0] = VAR_CHR(argv[3])[0];
			break;/* ?xxx?, nnn,? xxx? */
		}
	}
	
	if(!ISNILARG(4) && ISBLKARG(4))
		fgsAttachVar(&AsForBlock(pxSelf), argv[4]);
	
	if(!ISNILARG(5) && ISBLKARG(5))
	{
		fgsAttachVar(&AsWhileBlock(pxSelf), argv[5]);
		AsScope(pxSelf)  = AsRest;
	}
	
	if (!ISNILARG(6) && ISNUMARG(6))
	{
		AsScope(pxSelf) = fgsIntVar(argv[6]); /* The next- option value */
	}
	
	/* RECORD OPTION OVERRIDES everything else */
	if (!ISNILARG(7) && ISNUMARG(7))
	{
		AsScRec(pxSelf) =
		AsScope(pxSelf) = fgsIntVar(argv[7]);    /* The record-option val  */
	}
	
	/*
	 * NEW option
	 */
	if(ISNILARG(8) || ISTRUARG(8)) fgsSelect(IZERO_VAR, 0);
	
    AsDbStatus(pxSelf) &= ~DBF_CLOSED;                /* mark it as open */
    AsDbStatus(pxSelf) |= DBF_OPEN;                   /* mark it as open */
    
	
	AsBufSize(pxSelf) = AsRecSize(pxSelf) + 1024L + AsFCount(pxSelf) * 2L;
	
	/* 2*fcount()  */
	AsBuffer(pxSelf)  = (FSchar *) Mmalloc(AsBufSize(pxSelf) + 1,
										   fgs_errmsg[20],
										   ERRTYP_FTL, RP_ALWAYS);
	
	
    AsRecord(pxSelf) = (FSuchar *) Mmalloc((long) AsRecSize(pxSelf),
										   fgs_errmsg[15],
										   ERRTYP_FTL, RP_ALWAYS);
    
    AsFldVar(pxSelf) = (FSvar **)
	                   Mmalloc((long) AsFCount(pxSelf) * sizeof(FSvar *),
							   fgs_errmsg[16], ERRTYP_FTL, RP_ALWAYS);
    
    AsFldUpdated(pxSelf) = (FSuchar *)
	                       Mmalloc((long) AsFCount(pxSelf) * sizeof(FSuchar),
								   fgs_errmsg[16], ERRTYP_FTL, RP_ALWAYS);
	
    asInvalidateFields(pxSelf);
    
    /*  Calculate positions of fields in record                             */
    for(iTmp = 1, ii = 0; (FSushort) ii < AsFCount(pxSelf); ii++)
    {
        AsFldPos(pxSelf, ii) = iTmp;
        iTmp += (FSulong) AsFChrLen(pxSelf, ii);
    }
    
	/*
	 *  Now that we've successfully opened the file
     *  we need to introduce its alias and workarea
	 *  before creating the field vars for the area
	 */
	
	if(fgsAnnounceAlias(argv[0],
						AsFileSpec(pxSelf), (FSchar *) AsAlias(pxSelf)) < 0)
	{
		goto error_out;
	}
	
    /*  Create field variables                                              */
    for(ii = 0; (FSushort) ii < AsFCount(pxSelf); ii++)
    {
        AsFldVar(pxSelf)[ii] = fgsAnnounceField(AsFName(pxSelf, ii),
												ii + 1,
												AsFType(pxSelf, ii),
												1,
												AsFLen(pxSelf, ii),
												AsFDec(pxSelf, ii),
												AsField(pxSelf, ii));
    }
	
	/*
	 *  Simulated go top, if no record meets condition -> EOF
	 */
	vTmp1 = AsMeName(skip)(1, argv);
	if(!VAR_INT(vTmp1)) AsEof(pxSelf) = 1;
	
 short_out:
	
	fgsSetNeterr(0);
	
    return argv[0];
	
 error_out:  
	
	AsMeName(close)(1, argv);
	fgsSetNeterr(1);
	
    return argv[0];
}
/* EOF asinit.c */
