#ifdef COMMENT_ONLY
/* For FlagShip 5 
 * Copyright (c) 2001 by multisoft GmbH, Munich, Germany 
 *
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2001/07/30 14:04:55 $
 */
#endif

#include "asgener.h"

static char *fileID="@@#asciRdd:Skip() $Revision: 1.3 $";

#define FOR_STAT()    fgsTrueBlockEval(AsForBlock(pxSelf))
#define WHILE_STAT()  fgsTrueBlockEval(AsWhileBlock(pxSelf))

/*--------------------------------------------------------------------------*
 | AsciRdd:Skip() - according to the conditions set in AsciRdd:Init()       |
 |   note: this driver support only forward SKIP +1, ignores SKIP -n|0      |
 | argv[0] = oRdd                                                           |
 | argv[1] = optional, skip count (0 and -n -> ignored, +n -> +1)           |
 *--------------------------------------------------------------------------*/
AsMethod(skip)
{
	AsMethodObjPtr(pxSelf);
	FSint tmps_before = VAR_DEL_MARK();
	FSint itHasRec    = 0;
	FSint iOldPos     = 0;

   /* ignore SKIP 0 (performed also by SELECT) and SKIP -n 
    */
   if(argc > 1 && IS_VAR_NUM(argv[1]) && VAR_INTNUM(argv[1]) <= 0)
      return ZERO_VAR;
   
   /* perform SKIP +1, consider NEXT n, WHILE cb, FOR cb
    */
	while(AsScope(pxSelf))                         /* still in valid scope */
	{
		iOldPos = ftell(AsFh(pxSelf));
		
		++AsCurRec(pxSelf);                        /* go on one record     */
		asReadBuff(pxSelf);
		
		if(AsEof(pxSelf)) break;                   /* EOF hit              */

		if(AsWhileBlock(pxSelf) && !WHILE_STAT())  /* end of while cond    */
		{
			/*
			 *  Reposition to the last valid record
			 */
			fseek(AsFh(pxSelf), iOldPos, SEEK_SET);

			--AsCurRec(pxSelf);                    /* go back one record   */
			asReadBuff(pxSelf);
			break;
		}
		
		if(AsScope(pxSelf) > 0) --AsScope(pxSelf);/* reduce scope if given */

		if (   (AsScRec(pxSelf)  && (AsCurRec(pxSelf) == AsScRec(pxSelf)))
			|| (!AsScRec(pxSelf) && (!AsForBlock(pxSelf) || FOR_STAT())))
		{
			/*
			 *  This record meets the condition
			 */
			itHasRec = 1;
			break;
		}
		VAR_DEL_SINCE_MARK(tmps_before);
	}
	VAR_DEL_SINCE_MARK(tmps_before);

	return itHasRec ? ONE_VAR : IZERO_VAR;
}
/* EOF asskip.c */
