#ifdef COMMENT_ONLY
/* For FlagShip 5 
 * Copyright (c) 2001 by multisoft GmbH, Munich, Germany 
 *
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2001/07/30 14:04:55 $
 */
#endif

/*--------------------------------------------------------------------------*
 | asstruct.h                structures of the entire asci   RDD            |
 *--------------------------------------------------------------------------*/

#if !defined(_AS_STRUCT_H_)
#define _AS_STRUCT_H_

typedef struct xFldDef
{
   FSchar name[11];           /* field name (10 chars + 0 delimiter)        */
   FSchar type;               /* field type (C, N, D, L, M)                 */
   FSulong pos;               /* calculated offset in record                */
   FSuchar len;               /* total length of field (in bytes)           */
   FSuchar dec;               /* number of decimal places (for N type)      */
} xFldDef;

typedef struct xAsciRdd
{
   FSchar      name[250];      /* DBF file name (full path)                  */
   FSuchar     alias[15];      /* work area dbf name or ALIAS                */
   FSchar      acDelimiter[2];
   FSuchar     stat;           /* DBF status (open, close)                   */
   FSchar      eof;
   FSushort    fldcnt;         /* number of fields in record (F1)            */
   FSushort    reclen;         /* claculated record size                     */
   FSint       iBuffSize;
   FSulong     recno;
   FILE      * fh;             /* DBF file descriptor for input              */
   FSvar    ** fldvar;         /* poiters to variables containing flds       */
   FSuchar   * rec_buf;        /* pointer to buffer with current record      */
   FSchar    * pacBuffer;
   FSuchar   * updated_fields; /* flags for updated fields                   */
   FSvar     * For_cond;       /* If given, it's a codeblock                 */
   FSvar     * Wh_cond;        /* If given, it's a codeblock                 */
   FSulong     Sc_scope;       /* record position or count for REC / NEXT    */
   FSint       iRecord;
   xFldDef   * pxFldDefs;      /* field descriptions                         */
} xAsciRdd;

#endif
/* EOF asstruct.h */
