* For FlagShip 4, 5 and 6 
* Copyright (c) 2000..07 by multisoft, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2007/08/23 16:09:16 $
*
* Copy the source to your working directory, and
* Compile: FlagShip -na -c -w -m -io=a browsedb.prg 
* Link   : FlagShip myapp*.prg browsedb.o|obj 

#Cinline
static char *fileID="@@# $RCSfile: browsedb.prg,v $ $Revision: 1.4 $ $Date: 2007/08/23 16:09:16 $";
#endCinline

/****************************************************************************
 * Function tbrowsedb       Generates a tbrowse object according to the dbf *
 * In : p1 (N) Upper Border                                                 *
 *      p2 (N) Left  Border                                                 *
 *      p3 (N) Lower Border                                                 *
 *      p4 (N) Right Border                                                 *
 * Out: fn (Browse-Obj) on success, NIL_VAR else                            *
 *--------------------------------------------------------------------------*
 * (c) 1995 multisoft Datentechnik GmbH, Germany.                           *
 ****************************************************************************/

#include "tbrclass.fh"

PROTO FUNC TBrowseNew(t AS Intv, l AS Intv, b AS Intv, r AS Intv) AS TBrowse
PROTO FUNC __tbroskip(toskip AS Intvar)                           AS Intvar


FUNC tbrowsedb        ([@Top           AS Intv], ;
                       [@Left          AS Intv], ;
                       [@Bottom        AS Intv], ;
                       [@Right         AS Intv]  ) AS TBrowse

* local ii, fieldc, col

* fieldc = fcount()
* if fieldc < 1
*    return(NIL)
* endif

LOCAL obj := tbrowsenew(top, left, bottom, right) AS Tbrowse
obj:gobottomblock := { || dbgobottom()}
obj:gotopblock    := { || dbgotop()}
obj:skipblock     := { |xx| __tbroskip(xx)}

* for ii = 1 to fieldc
*   col := tbcolumnnew(fieldname(ii), fieldblock(fieldname(ii)))
*   obj:addcolumn(col)
* next

return(obj)



*****************************************************************************
* Function __tbroskip                 The Skipblock of tbrowsenew() objects *
*                                     Actually the same as dbskip, but will *
*                                     not position onto eof.                *
* In : p1 (N) Number of Records to skip                                     *
* Out: fn (N) Number of Records really skipped                              *
*****************************************************************************
function __tbroskip(toskip AS Intvar)  AS Intvar
local xx := dbskip(toskip) AS Intvar
if !eof()
    return (xx)
else
    skip -1
    return(xx - 1)
endif
* EOF browsedb.prg *
