/****************************************************************************
 * rddcb4t.c     RDD API for the CB4FOX, CB4CDX, CB4NDX, CB4MDX and CB4NTX  *
 *               by using CodeBase 5.1 multiplatform version (not included  *
 *               in the FlagShip package, contact Sequiter Inc.)            *
 *                                                                          *
 *               Test module, prints content of the current object          *
 *                                                                          *
 *               .prg call: CB4CDXTEST () --> out to /dev/stderr            *
 *               .c   call: cb4cdxTest ()                                   *
 *                                                                          *
 * (c) 1995..2004 multisoft Datentechnik GmbH, Munich. All rights reserved  *
 * Release $Date: 2004/10/27 10:03:02 $                                     *
 ****************************************************************************/

#include "rddcb4fs.h"                            /* RDD API for CodeBase    */

#if S4VERSION == 6502
#include "rddcb4cpp.h"
#endif

extern FSvar  *CB4FSudf(getCurrRDDobject)();     /* in rddcb4a.c            */
extern FSvar  *fsFnNAME(procname)();             /* std fn procname()       */
extern FSvar  *fsFnNAME(procline)();             /* std fn procline()       */

/* ------------------------------------------------------------------------ */
static int outVar(inVar)
FSvar * inVar;
{
   fprintf (stderr,"(%c) ",VAR_ISTYPE(inVar));
   switch (VAR_ISTYPE(inVar)) {
      case 'A': fprintf (stderr,"ARRAY[%d]",VAR_ISDIM(inVar)); break;
      case 'O': fprintf (stderr,"OBJECT");                     break;
      case 'U': fprintf (stderr,"NIL");                        break;
      case 'b':
      case 'B': fprintf (stderr,"CodeBlock"); break;
      case 'C':
      case 'E':
      case 'M': fprintf (stderr,"[%s]", VAR_CHR(inVar));      break;
      case 'I':
      case 'F':
      case 'N': fprintf (stderr," %d ", VAR_INTNUM(inVar));   break;
      case 'L': fprintf (stderr," %d ", VAR_LOG(inVar));      break;
      case 'D': fprintf (stderr," %d ", VAR_DATE(inVar));     break;
   }
   return 0;
}

/* -----------rddTestOut("text",line)-------------------------------------- */
FSvar *CB4FSudf(rddTestOut)(text, lineno)
char *text;
int lineno;
{

   DATA4 *dataPtr;
   FSvar *ovSelf, *aSubArr, *aSubSub;
   FSint ii;
   long lockedRec;
   
   ovSelf = CB4FSudf(getCurrRDDobject)();
   fprintf (stderr,"\n\n------ %s / %d ------- %s",
                  VAR_CHR(fsFnNAME(procname)(0,0)),
                  VAR_INTNUM(fsFnNAME(procline)(0,0)), text);
   if (lineno > 0)
      fprintf(stderr, " (line %d)", lineno);

   if (!IS_VAR_OBJ(ovSelf)) {
      fprintf (stderr," object not allocated\n");
      return NIL_VAR;
   }
   dataPtr = CB4FS_GETDATA4PTR;
   fprintf (stderr,"\novSelf[CB4OBJ_DATA4       ] = ptr to 0x%X", dataPtr);
   if (!dataPtr)
      fprintf (stderr," ** database is not open **");
   else {
      fprintf (stderr, "\n        .dbf version, alias = %d=0x%X [%s]",
#ifdef CODEBASE6
			   (unsigned char)(dataPtr->dataFile->version),
			   (unsigned char)(dataPtr->dataFile->version),
#else
			   (unsigned char)(dataPtr->version),
			   (unsigned char)(dataPtr->version),
#endif
			   dataPtr->alias);
      fprintf (stderr,"\n          rec_num, num_recs = %d, %d",
			   dataPtr->rec_num,
#ifdef CODEBASE6
			   dataPtr->dataFile->numRecs);
      if (dataPtr->dataFile->numRecs < 0L)
#else
			   dataPtr->num_recs);
      if (dataPtr->num_recs < 0L)
#endif
         fprintf (stderr," (%d)", d4reccount(dataPtr));
      if (dataPtr->rec_num > d4reccount(dataPtr)) fprintf(stderr, " * eof *");

#ifdef CODEBASE6
      fprintf (stderr, "\n              n_fields_memo = %d",
			   dataPtr->dataFile->nFieldsMemo);
# if S4VERSION == 6502
      lockedRec = CB4FS_cpp_LockedRec(dataPtr);   /* CB6.54 requires c++ */
      fprintf (stderr, "\n  num_locked = %d", lockedRec);
      fprintf (stderr, "\n     file_lock, append_lock = %d, %d",
                 dataPtr->dataFile->fileClientWriteLock
               | dataPtr->dataFile->fileServerWriteLock,
                 dataPtr->dataFile->appendClientLock
               | dataPtr->dataFile->appendServerLock);
# else
      lockedRec = dataPtr->dataFile->lockedRecords.n_link;/* CB6.1 structure     */
      fprintf (stderr, "\n  num_locked = %d", lockedRec);
      fprintf (stderr, "\n     file_lock, append_lock = %d, %d",
                 dataPtr->dataFile->fileClientLock
               | dataPtr->dataFile->fileServerLock,
                 dataPtr->dataFile->appendClientLock
               | dataPtr->dataFile->appendServerLock);
# endif
      fprintf (stderr, "\n        record/file_changed = %d, %d",
			   dataPtr->record_changed, dataPtr->dataFile->fileChanged);
#else
      fprintf (stderr, "\n              n_fields_memo = %d",
			   dataPtr->n_fields_memo);
      fprintf (stderr, "\n  locked_record, num_locked = %d, %d",
			         dataPtr->locked_record,dataPtr->num_locked);
      fprintf (stderr, "\n     file_lock, append_lock = %d, %d",
			   dataPtr->file_lock, dataPtr->append_lock);
      fprintf (stderr, "\n        record/file_changed = %d, %d",
			   dataPtr->record_changed, dataPtr->file_changed);
#endif
   }
   fprintf (stderr,"\novSelf[CB4OBJ_INDEX4ARR   ] = ");
   if (! IS_VAR_ARR(VAR_OBJ(ovSelf,CB4OBJ_INDEX4ARR)))
      outVar (VAR_OBJ(ovSelf,CB4OBJ_INDEX4ARR));
   else {
      aSubArr = VAR_OBJ(ovSelf,CB4OBJ_INDEX4ARR);
      for (ii=1; ii <= VAR_ISDIM(aSubArr); ii++) {
         aSubSub = VAR_ARRELEM(aSubArr, ii);
         fprintf (stderr,"\n   [%d,CB4OBJ_INDEX_FNAME] = ",ii); outVar(VAR_ARRELEM(aSubSub,CB4OBJ_INDEX_FNAME));
         fprintf (stderr,"\n   [%d,CB4OBJ_INDEX_TNAME] = ",ii); outVar(VAR_ARRELEM(aSubSub,CB4OBJ_INDEX_TNAME));
         fprintf (stderr,"\n   [%d,CB4OBJ_INDEX_TNUMB] = ",ii); outVar(VAR_ARRELEM(aSubSub,CB4OBJ_INDEX_TNUMB));
         fprintf (stderr,"\n   [%d,CB4OBJ_INDEX_I4NEW] = ",ii); outVar(VAR_ARRELEM(aSubSub,CB4OBJ_INDEX_I4NEW));
         fprintf (stderr,"\n   [%d,CB4OBJ_INDEX_I4PTR] = ptr to 0x%X", ii, VAR_SPECIAL(VAR_ARRELEM(aSubSub,CB4OBJ_INDEX_I4PTR)));
         fprintf (stderr,"\n   [%d,CB4OBJ_INDEX_T4PTR] = ptr to 0x%X", ii, VAR_SPECIAL(VAR_ARRELEM(aSubSub,CB4OBJ_INDEX_T4PTR)));
      }
   }
   fprintf (stderr,"\novSelf[CB4OBJ_DRIVERNAME  ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_DRIVERNAME));
   fprintf (stderr,"\novSelf[CB4OBJ_FILEINPNAME ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_FILEINPNAME));
   fprintf (stderr,"\novSelf[CB4OBJ_FILEFULLNAME] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_FILEFULLNAME));
   fprintf (stderr,"\novSelf[CB4OBJ_FILEOPENMODE] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_FILEOPENMODE));
   fprintf (stderr,"\novSelf[CB4OBJ_CONCURRENCY ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_CONCURRENCY));
   fprintf (stderr,"\novSelf[CB4OBJ_ERROBJECT   ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_ERROBJECT));
   fprintf (stderr,"\novSelf[CB4OBJ_DBF_EXT     ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_DBF_EXT));
   fprintf (stderr,"\novSelf[CB4OBJ_DBT_EXT     ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_DBT_EXT));
   fprintf (stderr,"\novSelf[CB4OBJ_IDX_EXT     ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_IDX_EXT));
   fprintf (stderr,"\novSelf[CB4OBJ_FOR_COND    ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_FOR_COND));
   fprintf (stderr,"\novSelf[CB4OBJ_WHI_COND    ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_WHI_COND));
   fprintf (stderr,"\novSelf[CB4OBJ_SCOPE       ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_SCOPE));
   fprintf (stderr,"\novSelf[CB4OBJ_DELIMITER   ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_DELIMITER));
   fprintf (stderr,"\novSelf[CB4OBJ_LOCATEBLOCK ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_LOCATEBLOCK));
   fprintf (stderr,"\novSelf[CB4OBJ_FILTERSTRING] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_FILTERSTRING));
   fprintf (stderr,"\novSelf[CB4OBJ_FILTERBLOCK ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_FILTERBLOCK));
   fprintf (stderr,"\novSelf[CB4OBJ_RELCOUNT    ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_RELCOUNT));
   fprintf (stderr,"\novSelf[CB4OBJ_RELATIONS   ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_RELATIONS));
   fprintf (stderr,"\novSelf[CB4OBJ_FOUNDFLAG   ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_FOUNDFLAG));
   fprintf (stderr,"\novSelf[CB4OBJ_LOCATERECNO ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_LOCATERECNO));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXFORSTR ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXFORSTR));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXDESC   ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXDESC));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXEFFECT ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXEFFECT));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXORDNUM ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXORDNUM));
#ifdef CB4FS_CBLOCK_SUPPORT
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXFORBLK ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXFORBLK));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXWHIBLK ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXWHIBLK));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXRECBLK ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXRECBLK));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXSTEP   ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXSTEP  ));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXRECSTAR] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXRECSTAR));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXRECNEXT] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXRECNEXT));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXRECORD ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXRECORD ));
   fprintf (stderr,"\novSelf[CB4OBJ_INDEXREST   ] = "); outVar(VAR_OBJ(ovSelf,CB4OBJ_INDEXREST   ));
#endif
   fprintf (stderr,"\n");
   return ovSelf;
}

/* -----------CB4CDXTEST ([cText])----------------------------------------- */
FSudfname (cb4cdxtest)                        /* cb4cdxTestObj (argc, argv) */
{
   if (argc > 0 && IS_VAR_CHR(argv[0]))
      return CB4FSudf(rddTestOut)(VAR_CHR(argv[0]), 0);
   else
      return CB4FSudf(rddTestOut)("", 0);
}

/* eof */

