/* $Id: labedit.prg,v 1.2 2000/06/29 17:55:07 vasa Exp $
 * $Log: labedit.prg,v $
 * Revision 1.2  2000/06/29 17:55:07  vasa
 *  changes compared to FS4.48.452: fn() and local prototyping
 *
 * Revision 1.1.1.1  2000/05/25 14:44:43  vasa
 *  imported from sccs for FS5.0
 * 4.3 97/06/17 10:17:57 itannir
 *    valtype() checks changed to comparison with NIL because of prototyped parameters
 * 4.2 97/06/09 14:42:44 itannir
 *    added prototypes and types for locals
 * 4.1 95/11/20 10:24:46 itannir
 */

/****************************************************************************
 * Compile: FlagShip labedit.prg -m -na -c [-nl -nL -nd]                    *
 * Rev. 4.03                                                                *
 *--------------------------------------------------------------------------*
 * Copyright 1993 (c) multisoft GmbH, Germany                               *
 ****************************************************************************/
#ifdef FlagShip
#Cinline
static char *fileID="@@# $RCSfile: labedit.prg,v $ $Revision: 1.2 $ $Date: 2000/06/29 17:55:07 $";
#endCinline
#include "inkey.fh"
#else
#include "inkey.ch"
#endif

#include "label.fh"

PROTO        FUNC __labdbname ([p1], [p2], [p3], [p4])           AS Usual
PROTO        FUNC __labdbf    (p1, p2, p3, [p4])                 AS Usual
PROTO        FUNC __labsave   (p1, p2, p3, p4)                   AS Usual
PROTO        FUNC __labsize   (p1, p2, p3, [p4])                 AS Usual
PROTO        FUNC __labspec   (p1, p2, p3, p4)                   AS Usual
PROTO        FUNC __labsiz1   (p1, p2, p3, p4)                   AS Usual
PROTO        FUNC __labsiz2   (p1, p2, p3, p4)                   AS Usual
PROTO        FUNC __labspec0  (p1, p2, p3, p4)                   AS Usual
PROTO        FUNC __labspec1  (p1, p2, p3, p4)                   AS Usual
PROTO        FUNC getactive   ([p1 AS Usual])                    AS Usual
PROTO STATIC FUNC out_box     (boxno AS Intvar, type AS Intvar)  AS Usual
PROTO STATIC FUNC msg_out     (msg   AS String)                  AS Usual
PROTO STATIC FUNC __labchk    ( )                                AS Logical



// #define GERMAN

STATIC defsize, text, label_data[0]              AS Array
STATIC colors := {{"W+/B,N/W" ,"W+/N,N/W"}, ;              // std.output
                  {"GR+/B,N/W","W/N,N/W" }, ;              // active window
                  {"BG+/B,N/W","W/N,N/W" }, ;              // messages
                  {"W/B,W/B"  ,"W/N,W/N" } }     AS Array  // dbf fields
STATIC msg_row, bottom_row, window := 0          AS Intvar
STATIC colset, size_elem := 1, lastchoice := 1   AS Intvar
STATIC modify                                    AS Logical
STATIC msg_txt, dbfname := "", glfilename := ""  AS String

* +-------------------------------------------------------------------------+
* | MAIN ENTRY using the command LABEL EDIT <filename>                      |
* |                                                                         |
* +-------------------------------------------------------------------------+
FUNC __labeledit      (  FileName       AS Char , ;
                       [@Defaults       AS Arra], ;
                       [@Messages       AS Arra]  ) AS Usua
LOCAL ok := .T.                                       AS Logical
LOCAL oldselect := SELECT()                           AS Intvar
LOCAL oldcolor := SETCOLOR()                          AS String
LOCAL screen := SAVESCREEN (0,0, MAXROW(),MAXCOL())   AS Screen
LOCAL data                                            AS Usual
LOCAL fukeys := { setkey(K_F2), setkey(K_F3), setkey(K_F5), setkey(K_F6), ;
                  setkey(K_F10), setkey(K_PGUP), setkey(K_PGDN) } AS Array

colset     := if (ISCOLOR(), 1, 2)
msg_row    := MAXROW()
bottom_row := if (msg_row < 24, msg_row -1, msg_row -2)

glfilename := filename
size_elem  := lastchoice := 1

#ifdef GERMAN
defsize    :=     {{'89 x 381 mm, 16x1',    35,5,1, 1,0,0}, ;
                   {'89 x 381 mm, 16x2',    35,5,2, 1,0,0}, ;
                   {'89 x 381 mm, 16x3',    35,5,3, 1,0,0}, ;
                   {'101.5 x 432 mm, 16x1', 40,8,1, 1,0,0}, ;
                   {'81 x 279 mm 12x3',     32,5,3, 1,2,0}, ;
                   {'Benutzer-Definiert',   35,5,1, 1,0,0}}
#else
modify := .T.
if (defaults != NIL)                                                 ;
   .and. (valtype(defaults) == "A")                                  ;
   .and. (aeval(defaults,                                            ;
                {|_p1| modify = modify .and. (valtype(_p1) == "A")   ;
                                       .and. (len(_p1) == 7)}),      ;
          modify)
   defsize := defaults
else
   defsize :=     {{'3.5x15", 16x1', 35,5,1, 1,0,0},        ;
                   {'3.5x15", 16x2', 35,5,2, 1,0,0},        ;
                   {'3.5x15", 16x3', 35,5,3, 1,0,0},        ;
                   {'4x17", 16x1',   40,8,1, 1,0,0},        ;
                   {'3.2x11", 12x3', 32,5,3, 1,2,0},        ;
                   {'user defined ', 35,5,1, 1,0,0}}        // expand as needed
endif
#endif

if messages != NIL
    text = messages
else
#ifdef GERMAN
*------------------ german (or other) output ------------------------------
    text := ;
  {"       LABEL               F2:Gre F3:Daten F5:Felder  F10:Speichern ESC:Abbr", ;
   "NEUES ", ;
   "VORH. ", ;
   "Gre, Bemerkung     :", ;
   "Label-Breite (Zeich) :", ;
   "Label-Hhe   (Zeilen):", ;
   "Bahnen               :", ;
   "Zeilen zwisch.labels :", ;
   "Zeichen zwisch.labels:", ;
   "linker Rand  (Zeich) :", ;
   "(F2) PgUp/PgDn: Gre    CursUp/CursDn: Posit.   ENTER: Eingabe", ;
   "Zeile", ;
   "(F3) Feld oder Ausdruck eingeben.   CursUp/CursDn: Wahl   ENTER: Eingabe", ;
   "(F5) PgUp/PgDn, CursUp/CursDn: Wahl,Bewegung    ENTER: bernahme", ;
   "<->", ;
   "Dateiname falsch. Beliebige Taste fr Rckkehr", ;
   "Dateneingabe berprfen: TYPE() ist nicht Zeichen, Nummer, Datum oder Logisch", ;
   "Keine LABEL Daten eingetragen. Eintrag mit der F3 Taste, ESC fr Abbruch.", ;
   "F6:nchste dbf"}
#else
*------------------ english (default) output ------------------------------
    text := ;
  {"       LABEL               F2:size  F3:specify  F5:fields   F10:save  ESC:quit", ;
   "CREATE", ;
   "MODIFY", ;
   "Size, remark         :", ;
   "Label width  (chars) :", ;
   "Label high   (lines) :", ;
   "Label columns        :", ;
   "Lines between labels :", ;
   "Spaces between cols  :", ;
   "Left margin  (chars) :", ;
   "(F2) PgUp/PgDn: select size   CursUp/CursDn: move   ENTER: confirm", ;
   "Line ", ;
   "(F3) enter field or expression.  CursUp/CursDn: select,scroll   ENTER: confirm", ;
   "(F5) PgUp/PgDn, CursUp/CursDn: move, scroll    ENTER: overtake", ;
   "<->", ;
   "Wrong file name, press any key to return", ;
   "Check the correct entry: TYPE() not character, numeric, date or logical", ;
   "No LABEL data specified. Use F3 to specify, ESC to quit.", ;
   "F6:next dbf"}
#endif
endif

__labdbname ()

window := 2

SETCOLOR (colors[3,colset])

cls
@ 1,1 SAY text[1]

if empty(filename)
   filename := "????????.lbl"
   ok := .F.
elseif !("." $ filename)
   filename := trim(filename) + ".lbl"
end

SETCOLOR (colors[2,colset])
@ 1,14 say RIGHT(filename,14)

SETCOLOR (colors[1,colset])
if !ok
   setpos (10,1)
   WAIT text[14]                           // no file given, exit
   SETCOLOR (oldcolor)
   RESTSCREEN (0,0, MAXROW(),MAXCOL(), screen)
   RETURN .F.
end

modify := .F.
if FILE(filename)
   data := __labelstr (filename)
   modify := valtype(data) == 'A'
   if modify
      size_elem := len(defsize)                    // last element: user data
      defsize [size_elem,1] := data[LBL_REMARK]    // remark
      defsize [size_elem,2] := data[LBL_WIDTH]     // wide (chars)
      defsize [size_elem,3] := data[LBL_HEIGHT]    // high (lines)
      defsize [size_elem,4] := data[LBL_PERLINE]   // rows
      defsize [size_elem,5] := data[LBL_LNSPC]     // lines btw.labels
      defsize [size_elem,6] := data[LBL_COLSPC]    // chars btw.labels
      defsize [size_elem,7] := data[LBL_LFMARG]    // left margin
      label_data            := data[LBL_INFO]      // the strings
   endif
endif
asize(label_data, 16)

SETCOLOR (colors[3,colset])
@ 1,1 say IF (modify, text[3], text[2])
SETCOLOR (colors[1,colset])

out_box ( 2, 1)
out_box ( 3, 1)
out_box ( 5, 1)

CLEAR TYPEAHEAD

SET KEY K_F2   TO
SET KEY K_F3   TO
SET KEY K_F5   TO __labdbf
SET KEY K_F6   TO __labdbname
SET KEY K_F10  TO __labsave
SET KEY K_PGUP TO
SET KEY K_PGDN TO

BEGIN SEQUENCE
   DO __labdbf  WITH procname(), procline(), ""
   DO __labsize WITH procname(), procline(), ""
END

setkey(K_F2  , fukeys[1])
setkey(K_F3  , fukeys[2])
setkey(K_F5  , fukeys[3])
setkey(K_F6  , fukeys[4])
setkey(K_F10 , fukeys[5])
setkey(K_PGUP, fukeys[6])
setkey(K_PGDN, fukeys[7])

select (oldselect)
SETCOLOR (oldcolor)
RESTSCREEN (0,0, MAXROW(),MAXCOL(), screen)

/* release contents of some statics */
label_data := array(0)
dbfname    := ""
glfilename := ""
size_elem  := lastchoice := 1
defsize    := NIL
text       := NIL

RETURN NIL

* +-------------------------------------------------------------------------+
* | declare label size                                                      |
* |      entered by SET KEY TO F2_KEY                                       |
* +-------------------------------------------------------------------------+
FUNCTION __labsize (p1, p2, p3) AS Usual
LOCAL ii                   AS Intvar
LOCAL oldtext := (msg_txt) AS String
LOCAL getlist := {}        AS Array

window := 2

FOR ii := 1 to 7
   @ 3 + ii, 4 say text[3 + ii]
NEXT
msg_out (msg_txt:= text[11])

DO WHILE .T.
   out_box (2, 2)
   @ 10,47 say "#" + str(size_elem,1) COLOR colors[4,colset]

   SET KEY K_F3   TO __labspec
   SET KEY K_PGUP TO __labsiz1
   SET KEY K_PGDN TO __labsiz2
   defsize [size_elem,1] := PADR(defsize [size_elem,1], 60)
   @ 4, 46 say text[15]
   @ 4, 27 GET defsize [size_elem,1] PICT "@S19"
   FOR ii := 2 to 7
      @ 3 + ii, 27 GET defsize [size_elem,ii] PICT "999" VALID __labchk()
   NEXT
   READ
   SET KEY K_PGUP TO
   SET KEY K_PGDN TO
   SET KEY K_F3   TO
   if lastkey() == K_ESC
      BREAK
   endif
END
msg_txt := oldtext

RETURN


PROCEDURE __labsiz1 (p1, p2, p3)      // PgUp
size_elem := max (size_elem -1, 1)
CLEAR GETS
RETURN

PROCEDURE __labsiz2 (p1, p2, p3)      // PgDn
size_elem := min (size_elem +1, len(defsize))
CLEAR GETS
RETURN


STATIC FUNCTION __labchk () AS Logical
LOCAL get := GETACTIVE()       AS Usual
LOCAL elem                     AS Intvar

LOCAL range:= {{  0,   0}, ;
               {  1, 999}, ;              // wide (chars)
               {  1,  16}, ;              // high (lines)
               {  0, 999}, ;              // rows
               {  0, 999}, ;              // lines btw.labels
               {  0, 999}, ;              // chars btw.labels
               {  0, 999}}      AS Array  // left margin

elem := get:subscript[2]

if defsize [size_elem, elem] < range [elem,1] .or. ;
   defsize [size_elem, elem] > range [elem,2]
   RETURN .F.
endif
RETURN .T.

* +-------------------------------------------------------------------------+
* | specify label macros                                                    |
* |      entered by SET KEY TO F3_KEY                                       |
* |      F2 returns to window 2, PgDn performs CursDown                     |
* |      F5 selects window 5, overtaking fieldnames possible                |
* +-------------------------------------------------------------------------+
FUNCTION __labspec (p1, p2, p3) AS Usual
LOCAL ii, line := 1, maxline := defsize [size_elem,3]   AS Intvar
LOCAL oldwindow := window, choice  := 1                 AS Intvar
LOCAL oldtext := (msg_txt)                              AS String
LOCAL output[0], getlist := {}                          AS Array

CLEAR TYPEAHEAD
if window != 2
   return
endif

out_box ( 2, 1)
out_box ( 3, 2)

if defsize [size_elem,3] <= 0
   ?? chr(7)
   RETURN
endif

@ 13,4 clear to bottom_row-1,45

FOR ii := 1 to min(maxline, bottom_row -13)
   @ 12 + ii, 46 say text[15]
NEXT

window  := 3
msg_txt := text[13]
msg_out (msg_txt)

FOR ii := 1 to maxline
   label_data[ii] := if (label_data[ii]==NIL, ;
                         space(60), PADR(label_data[ii], 60))
   aadd (output, text[12] + str(ii,2) + ": " + ;
        substr(label_data[ii], 1,33))
NEXT

DO WHILE .T.
   SET KEY K_F2   TO __labspec0
   SET KEY K_PGDN TO __labspec1

   choice := achoice (13,4, bottom_row-1,45, output)

   DO CASE
   CASE choice == 0 .or. lastkey() == K_ESC
      exit
   CASE lastkey() == K_LEFT
      exit
   OTHERWISE
      @ ROW(), 4 SAY text[12] + str(choice,2) + ":" ;
                 GET label_data[choice] PICT "@S33"
      READ
      output[choice] := substr(output[choice],1,9) + ;
                        substr(label_data[choice],1,33)
      if lastkey() # K_ESC .and. !empty(label_data[choice]) .and. used()
         if !(TYPE(TRIM(label_data[choice])) $ "CDNL")
            ?? chr(7)
            msg_out (text[17])
            inkey(10)
            msg_out (msg_txt)
         endif
      endif
   ENDCASE
ENDDO

SET KEY K_F2   TO
SET KEY K_F3   TO __labspec
SET KEY K_PGDN TO __labsiz2

out_box ( 2, 2)
out_box ( 3, 1)

msg_txt := oldtext
window  := oldwindow
msg_out (msg_txt)

RETURN


PROCEDURE __labspec0 (p1, p2, p3)   // F2 key
KEYBOARD chr(K_LEFT)
RETURN

PROCEDURE __labspec1 (p1, p2, p3)   // PgDn key
KEYBOARD chr(K_DOWN)
RETURN


* +-------------------------------------------------------------------------+
* | show dbf fields                                                         |
* |      entered by SET KEY TO F5_KEY                                       |
* +-------------------------------------------------------------------------+
FUNCTION __labdbf  (p1, p2, p3, p4) AS Usual
LOCAL dbfdata[0], out[0]       AS Array
LOCAL ii, oldwindow:=(window)  AS Intvar
LOCAL element, choice := 0     AS Intvar
LOCAL value                    AS Usual
LOCAL actcolor := SETCOLOR()   AS String
LOCAL oldselect := SELECT()    AS Intvar

CLEAR TYPEAHEAD
if !used() .or. window = 5
   RETURN
endif

window := 5
out_box (oldwindow, 1)
out_box (5, 2)

dbfdata := DBSTRUCT()

FOR ii := 1 to len(dbfdata)
   aadd (out, PADR(dbfdata[ii,1],11) + dbfdata[ii,2] + ;
              STR(dbfdata[ii,3],4) +  STR(dbfdata[ii,4],4))
NEXT

SET KEY K_F2 TO __labspec0
SET KEY K_F3 TO __labspec0

@ 4,56 clear to bottom_row-1,75

if empty(p3)
   setcolor (colors[4,colset])
   achoice (4,56, bottom_row-1,75, out, .F.)
   setcolor (actcolor)
else
   choice = achoice (4,56, bottom_row-1,75, out, .t., , lastchoice)
endif
if choice > 0 .and. oldwindow == 3 .and. SELECT() == oldselect
   element:= GETACTIVE():SUBSCRIPT[1]
   value  := label_data[element]
   value  := PADR(trim(value) + trim(alias()) + "->" + ;
                  trim(substr(out[choice],1,10)), 60)
   label_data[element] := value
   lastchoice := choice
endif

out_box (5, 1)
out_box (oldwindow, 2)

window := oldwindow
if window = 2
   SET KEY K_F2 TO
   SET KEY K_F3 TO __labspec
endif

RETURN

* +-------------------------------------------------------------------------+
* | save the .lbl format                                                    |
* |      entered by SET KEY TO F10_KEY                                      |
* +-------------------------------------------------------------------------+
FUNCTION __labsave (p1, p2, p3) AS Usual
LOCAL ii         AS Intvar
LOCAL ok := .F.  AS Logical
LOCAL data[8]    AS Array

data[LBL_REMARK]  := defsize [size_elem,1]   // remark
data[LBL_WIDTH]   := defsize [size_elem,2]   // wide (chars)
data[LBL_HEIGHT]  := defsize [size_elem,3]   // high (lines)
data[LBL_PERLINE] := defsize [size_elem,4]   // rows
data[LBL_LNSPC]   := defsize [size_elem,5]   // lines btw.labels
data[LBL_COLSPC]  := defsize [size_elem,6]   // chars btw.labels
data[LBL_LFMARG]  := defsize [size_elem,7]   // left margin
data[LBL_INFO]    := label_data              // the messegaes

FOR ii := 1 to data[2]
   if !empty(label_data[ii])
      ok = .T.
      exit
   endif
NEXT

if !ok
   msg_out (text[18])
   inkey (10)
   msg_out (msg_txt)
   RETURN
endif

__labelstw (glfilename, data)

BREAK

* +-------------------------------------------------------------------------+
* | get next .dbf (F6 key)                                                  |
* +-------------------------------------------------------------------------+
function __labdbname (p1, p2, p3)  AS Usual
LOCAL ii, actselect := SELECT()  AS Intvar

if !used()
   return
endif

if window > 0 .and. p1 != NIL
   for ii := actselect +1 to 255
      select (ii)
      if used()
         exit
      endif
   next
   if ii > 255
      for ii := 1 to actselect
         select (ii)
         if used()
            exit
         endif
      next
   endif
end

lastchoice := 1
dbfname := DBF()
if dbfname != NIL .and. !empty(dbfname)
   if !("." $ dbfname)
      dbfname := trim(dbfname) + ".dbf"
   end
   if len(dbfname) > 21
      dbfname := "..." + right(dbfname,17)
   end
endif
if window # 5 .and. p1 != NIL
   __labdbf  ("", 0, "")
end
return

*+---------------------------------------------------------+
*| service: output box with header and specif.color        |
*+---------------------------------------------------------+
STATIC FUNCTION out_box (boxno AS Intvar, type AS Intvar)  AS Usual
LOCAL r1, r2, c1, c2               AS Intvar
LOCAL txt, actcolor := SETCOLOR()  AS String

DO CASE
CASE boxno = 2
   r1 := 3  ; c1 := 1 ; r2 := 11 ; c2 := 49 ; txt := "F2"
CASE boxno = 3
   r1 := 12 ; c1 := 1 ; r2 := bottom_row ; c2 := 49 ; txt := "F3"
OTHERWISE
   r1 := 3  ; c1 := 53; r2 := bottom_row ; c2 := 78 ; txt := "F5:" + dbfname
ENDCASE

if type = 2
   SETCOLOR(colors[2,colset])
   @ r1,c1 TO r2,c2 DOUBLE
else
   SETCOLOR(colors[1,colset])
   @ r1,c1 TO r2,c2
endif
@ r1,c1+1 SAY txt
if boxno = 5
   @ r2, c2 - len(text[19]) say text[19]
endif

SETCOLOR(actcolor)
RETURN NIL

*+---------------------------------------------------------+
*| service: output msg line                                |
*+---------------------------------------------------------+
STATIC FUNCTION msg_out (msg AS String) AS Usual
@ msg_row, 0
@ msg_row, int((MAXCOL() - len(msg)) / 2) SAY msg COLOR colors[3,colset]
RETURN NIL


*MODIFY LABEL xxxxxxxx.lbl  F2:size  F3:specify  F5:fields  F10:save  ESC:abort
*
*F2  F5:xxxxxxxx.dbf
*  Size, remark         : 12.3 x 23.5 cm, 3xx      xxxxxxxxxx C nnn nnn  
*  Width        (chars) : xxx                        xxxxxxxxxx C nnn nnn  
*  High         (lines) :                            xxxxxxxxxx C nnn nnn  
*  Rows                 :                            xxxxxxxxxx C nnn nnn  
*  Lines between labels :                            xxxxxxxxxx C nnn nnn  
*  Spaces between rows  :                            xxxxxxxxxx C nnn nnn  
*  Left margin  (chars) :                            xxxxxxxxxx C nnn nnn  
*     xxxxxxxxxx C nnn nnn  
*F3     xxxxxxxxxx C nnn nnn  
*  Line  1: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line  2: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line  3: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line  4: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line  5: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line  6: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line  7: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line  8: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  Line 99: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      xxxxxxxxxx C nnn nnn  
*  

*** eof labedit.prg ***

#ifdef __LBL_DEBUG
function __labelstw(data, label_data) // see line 428
for ii = 1 to 7
   ? "data[" + str(ii,2) + "]="
   ?? data[ii]
next
for ii = 1 to data[2]
   ? "spec[" + str(ii,2) + "]="
   ?? label_data[ii]
next
return nil
#endif
