/**************************************************************************
 * FlagShip 5.x : the Terminal i/o Printer class, reimplem.of _Printer class
 * Prototypes   : printerclass.fh 
 *
 * Compile with -na -c -io=t switch.
 *
 * For FlagShip 5. Copyright (c) 2002 by multisoft GmbH, Munich, Germany
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * Note: this source is intended mainly for your information. It may be 
 * changed without further notification in later FS release.
 * 
 * Release $Date: 2002/06/13 19:05:37 $
 */
 
#Cinline
static char *fileID="@@#IOTERM# _tPrinter{} $Revision: 1.3 $";
#  include "FSopenc.h"
#  include "malloc.h"
#endCinline


/**************************** _gPrinter *************************************/
#include "printerclass.fh"

CLASS _tPrinter INHERIT _Printer ALIAS Printer

/* --- instances are in printerclass.fh
 * --- basic _Printer methods are in o_printer.prg
 */

/*---------------------------------------------------------------------------
 * :ExecPrintScreen() -> lOk
 *    prints the whole user-screen to default spooler according to :SetUp()
 * The _oprinter:PrintScreen() is also executed from main menu, see 
 *    initiomenu.prg either via STATIC FUNCTION InitIoScrPrint(obj, menuID) 
 *    or user redefined
 -> Reimplemented in Terminal and GUI i/o
 */
METHOD ExecPrintScreen()                      CLASS _tPrinter

   LOCAL_INT ymax := MAXROW()                       // used also in C
   LOCAL     chr_arr[ymax +1] as array              // e.g. chr_arr[25]
   LOCAL status_print, status_cons, status_devi, status_to, tmpFile as usual
   LOCAL ii := 0 as intvar

   #Cinline
   {
      UDF_PROT(savescreen);                          
      UDF_PROT(maxcol);                              

      FSvar    *actscreen = VAR_NEW;
      WINDOW   *winPtr;
      int      x, y, xmax;
      unsigned char *oneLine, *str;

      actscreen = UDF_EXEC(savescreen)(0,0);         /* SAVE SCREEN   */
      winPtr    = VAR_SCR (actscreen);
      xmax      = (int) VAR_NUM (_bb_maxcol(0,0) );  /* xmax=MAXCOL() */
      oneLine = malloc( (unsigned) ((xmax +1) * sizeof(unsigned char)));
      if (oneLine != NULL) {
         for (y=0; y <= ymax; y++) {
            str = oneLine;
            for (x=0; x <= xmax; x++)
               *(str++) = (unsigned char)
                          (mvwinch(winPtr,y,x) & A_CHARTEXT); /*curses*/
            SET_VAR_CHRLEN (VAR_ARRELEM (VAR_NAME_LOCAL(chr_arr), y+1),
                            oneLine, xmax +1);
         }
         free (oneLine);
      }
      VAR_DELETE;
   }
   #endCinline

   /* create tempor. output file and print it via self:PrintFormatted()
    */
   status_cons  := SET (_SET_CONSOLE)           // SET CONSOLE on/off ?
   status_print := SET (_SET_PRINTER)           // SET PRINTER on/off ?
   status_to    := SET (_SET_PRINTFILE)         // SET PRINTER to ?
   status_devi  := SET (_SET_DEVICE)            // SET DEVICE  TO ??
   
   tmpFile := TempFileName()
   SET PRINTER TO (tmpFile)
   SET PRINTER ON
   SET CONSOLE OFF
   ? "Print Screen in proc/fn", procstack(1), "at", DATE(), TIME()
   AEVAL (chr_arr, {|x| QOUT(STR(ii++,2) + ":", x)} )
   ? SPACE(4) + REPLICATE("---------+", 8)
   ?
   SET DEVICE TO SCREEN
// ALERT ("The current screen is printed;to file " + FS_SET("print"))
   SET (_SET_DEVICE, status_devi)
   SET CONSOLE (status_cons)
   SET PRINTER (status_print)
   SET PRINTER TO (status_to)

   self:PrintFormatted(tmpFile)
   return .T.
    
/* eof */
