* For FlagShip 6 
* Copyright (c) 2004 by multisoft GmbH, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2004/01/29 15:24:49 $
*

#define USE_INTERNAL_TABLE    /* enable/disable on request, new in FS6 */

/*--------------------------------------------------------------------------
 * User modifiable System Function _SetSortab() 
 *    called from InitIo.prg to set default sorting table which is 
 *    usually located in
 *       - the current directory,
 *       - in the path in envir.variable SCRMAP,
 *       - in the path in envir.variable TERMINFO,
 *       - in the path in envir.variable FSTINFO
 *    If not found, prints a warning message to stderr device
 *
 * The default sort table is used mainly for lower/upper conversion 
 * of chars > 127 for both PC8 and ANSI.
 *
 * You may (preferrably) check at the beging of your application:
 *    if ! m->_SortingTableOk
 *       Alert("Warning: could not locate sorting table FSsortab.def,;" + ;
 *             "cannot proper convert chars > 127 to upper/lowercase;"  + ;
 *             "and will display warning for index created with sort table")
 *    endif
 *
 * To disable this default behavior, you may define same named function 
 * somewhere in your application with the desired functionality.
 */
FUNCTION _SetSortab() 
   local lOk as logic   
   
   lOk := FS_SET("loadlang",1,"FSsortab.def")
   if lOk
      CONSTANT _SortingTableOk := .T.
      FS_SET("setlang", 1)
#ifdef USE_INTERNAL_TABLE
   else
      // use internal sorting table corresponding to FSsortab.def
      
      lOk := FS_SET("loadlang",1,"-")
      if lOk
         CONSTANT _SortingTableOk := .T.
         FS_SET("setlang", 1)
      endif
#endif
   endif
   if !lOk
      CONSTANT _SortingTableOk := .F.
      
      // You may un-comment the following two lines to display
      // a warning at the start-up of the aplication
        
*     ??## "Warning: could not locate sorting table FSsortab.def,"
*     ??## "   cannot proper convert chars > 127 to upper/lowercase"
   endif

return NIL

*eof*
