** simple test for the SmallRDD.PRG == smallRDD driver.
** Compile: FlagShip srddtest.prg smallrdd.prg
*
* Release $Date: 2005/09/27 18:22:26 $

#include "smallRDD.fh"

extern smallRDDNew

set print on

// if !file("srddtest.dbf")
   /*
    * create database if not exist yet
    * Note: uses default DBFIDX driver, since CreateDb() method is  
    * not available in the smallRDD driver
    */
   dbcreate ("srddtest.dbf",           ;
             {{"char1", "c",  10, 0},  ;
              {"char2", "c", 300, 0},  ;
              {"num1" , "n",   2, 0},  ;
              {"num2" , "n",  15, 3},  ;
              {"dat1" , "d",   8, 0},  ;
              {"log1" , "l",   1, 0}} )
   use srddtest alias orig
   append blank
   repla char1 with "One", char2 with "Rec1 long.." + space(284) + "..end"
   repla num1  with 1, num2 with 11111111111.111
   repla dat1  with date(), log1 with .T.

   append blank
   repla char1 with "Two-", char2 with "Rec2 long.." + space(284) + "..end"
   repla num1  with 22, num2 with -2222222222.222
   repla dat1  with date() +1, log1 with .F.

   USE      // close database
// endif

/* process database using the smallRDD driver and standard commands
 */ 
USE srddtest NEW VIA smallRDD
? "--- step 1: command usage of the smallRDD driver"
? "used() :", used(), "alias=", Alias(), "WA=", select()
if !used()
	? "sorry, cannot open database 'srddtest.dbf' - file permission?"
	wait
	quit
endif

? "--struct--"
aeval (dbstruct(), {|x| qout(padr(x[1],10), x[2], x[3], x[4])})
? "--list--"
while !eof()
   ? recno(), char1, num1, num2, dat1, log1
   skip
enddo

goto 1
? "-- replacing fields char1, num1, num2"
// check access and assign of fields,
// replace first record
? "recno=", recno()
f1 := field->char1
f2 := srddtest->num1
f3 := num2
field->char1 := "new 1"
srddtest->num1 := 99
replace num2 with 9999.9
? "old CHAR1 = '" + f1 + "'"
? "new CHAR1 = '" + field->char1 + "'"
? "old NUM1  = ", f2 
? "new NUM1  = ", srddtest->num1
? "old NUM2  = ", f3 
? "new NUM2  = ", num2
skip
? "--list--"
** go top       = unsupported, smallRdd:GoTop()  is not defined
** list command = unsupported, smallRdd:Eval() & DbEval() not available
goto 1
while !eof()
   ? recno(), char1, num1, num2, dat1, log1
   skip
enddo
 
/* process database using the smallRDD driver and it object
 */ 
oUntyped := DBOBJECT()
goto 1
?
? "--- step 2: untyped object usage of the smallRDD driver"
? "oUntyped:Used :", oUntyped:Used, "alias=", oUnTyped:Alias, "WA=", select()
if oUntyped:Used
   while ! oUntyped:eof
      ? oUntyped:recno, char1, num1, num2, dat1, log1
      oUntyped:skip()
   enddo
endif
* oUntyped:displayInstances(.T.)
USE      // close database
? "oUntyped:Used :", oUntyped:Used


local oTyped as smallRDD
?
? "--- step 3: typed object usage of the smallRDD driver"
oTyped := smallRDD {"srddtest"}
? "oTyped:Used :", oTyped:Used, "alias=", oTyped:Alias, "WA=", select()
? "--replacing CHAR1 of second record"
if oTyped:Used
	otyped:Goto(2)
	oTyped:char1 := "new rec2"
	oTyped:goto(1)
   while ! oTyped:eof
      ? oTyped:recno, char1, oTyped:fieldget("num1"), oTyped:num2, ;
         fieldget("dat1"), log1
      oTyped:skip()
   enddo
endif
oTyped:goto(1)
?
? "--- step 4: command usage of the typed RDD"
while !eof()
   ? recno(), char1, num1, num2, dat1, log1
   skip
enddo
? "--- step 5:"
aeval (oTyped:dbstruct(), {|x| qout(padr(x[1],10), x[2], x[3], x[4])})

wait
