#ifdef COMMENT_ONLY
* For FlagShip 5 
* Copyright (c) 2002 by multisoft GmbH, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2002/07/10 19:30:31 $
*
#endif

#include "tbrclass.fh"
#include "FSerrmsg.h"

PROTO FUNCTION TbrArrSkip(toskip as intvar, obj as Tbrowse)
PROTO FUNCTION TbrArrTop(obj as Tbrowse)
PROTO FUNCTION TbrArrBottom(obj as Tbrowse)
PROTO FUNCTION TbrHandler(oTbr as Tbrowse) as usual

/****************************************************************************
 * Function TbrowseArr       Generates a tbrowse object handling array access 
 * In : p1 (N) Upper Border                                                 
 *      p2 (N) Left  Border                                                 
 *      p3 (N) Lower Border                                                 
 *      p4 (N) Right Border    
 *      p5 (L) optional = .T. or .F. if pixels/rows, NIL=SET PIXEL
 *      p6 (L) optional = .T. resizeable by user, .F. fix (default)
 *      p7 (C) optional = tooltip string, see also oTbrowse:ToolTip
 *      p8 (O) optional = font object 
 *      p9 (I) optional = row height in pixel, see also oTbrowse:RowHeight
 *      p10(A) optional = user array, see also oTbrowse:UserArray                                              
 * Out: fn (Browse-Obj) on success, NIL_VAR else                            
 *--------------------------------------------------------------------------
 * Copy the source to your working directory, 
 *   make a symb.link according to the compilation switch, e.g.
 *   ln -s tbrowsearr.prg tbrowsearr_g.prg
 * Compile: FlagShip -na -c -w -m [-FSintern] -io=b|g|t tbrowsearr_?.prg
 * Link   : FlagShip myapp*.prg tbrowsearr_?.o [-io=a|g|t|b] [-o myapp]
 ****************************************************************************/
#ifdef FSIO_GUI
FUNCTION _g_TbrowArr(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10) as usual
   LOCAL obj := _gTbrowse{p1, p2, p3, p4, p5, p6, p7, p8, p9} AS Tbrowse
#endif
#ifdef FSIO_TERM
FUNCTION _t_TbrowArr(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10) as usual
   LOCAL obj := _tTbrowse{p1, p2, p3, p4} AS Tbrowse
#endif
#ifdef FSIO_BASIC
FUNCTION _b_TbrowArr(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10) as usual
    _Rt_Error(DEVWARNING, "TBrowseArr() is not available in basic mode")
    return NIL
#endif

#ifndef FSIO_BASIC
   local ii, fieldc, col as usual

   if valtype(p10) == "A"
      obj:UserArray := p10
   endif
   
   obj:UserArrayPos  := 1
   
   obj:gobottomblock := { |obj|    TbrArrBottom(obj) }   // in tbrowsehand.prg
   obj:gotopblock    := { |obj|    TbrArrTop(obj) }      // in tbrowsehand.prg
   obj:skipblock     := { |xx,obj| TbrArrSkip(xx, obj) } // in tbrowsehand.prg
   obj:Handler       := { |obj|    TbrHandler(obj) }     // in tbrowsehand.prg

return(obj)

#endif
* EOF browsearr.prg *
