#ifdef COMMENT_ONLY
* For FlagShip 5 
* Copyright (c) 2002 by multisoft GmbH, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2003/10/04 15:24:59 $
*
#endif

#include "tbrclass.fh"
#include "FSerrmsg.h"

PROTO STATIC FUNCTION __tbroskip(p1) as usual

/****************************************************************************
 * Function TbrowseDB       Generates a tbrowse object according to the dbf 
 * In : p1 (N) Upper Border                                                 
 *      p2 (N) Left  Border                                                 
 *      p3 (N) Lower Border                                                 
 *      p4 (N) Right Border                                                 
 *      p5 (L) optional = .T. or .F. if pixels/rows, NIL=SET PIXEL
 *      p6 (L) optional = .T. resizeable by user, .F. fix (default)
 *      p7 (C) optional = tooltip string, see also oTbrowse:ToolTip
 *      p8 (O) optional = font object 
 *      p9 (I) optional = row height in pixel, see also oTbrowse:RowHeight
 * Out: fn (Browse-Obj) on success, NIL_VAR else                            
 *--------------------------------------------------------------------------
 * Copy the source to your working directory, 
 *   make a symb.link according to the compilation switch, e.g.
 *   ln -s tbrowsedb.prg tbrowsedb_g.prg
 * Compile: FlagShip -na -c -w -m [-FSintern] -io=b|g|t tbrowsedb_?.prg
 * Link   : FlagShip myapp*.prg tbrowsedb_?.o [-io=a|g|t|b] [-o myapp]
 ****************************************************************************/
#ifdef FSIO_GUI
FUNCTION _g_TbrowDb(p1, p2, p3, p4, p5, p6, p7, p8, p9) as usual
   LOCAL obj := _gTbrowse{p1, p2, p3, p4, p5, p6, p7, p8, p9} AS _gTbrowse
#endif
#ifdef FSIO_TERM
FUNCTION _t_TbrowDb(p1, p2, p3, p4, p5, p6, p7, p8, p9) as usual
   LOCAL obj := _tTbrowse{p1, p2, p3, p4} AS _tTbrowse
#endif
#ifdef FSIO_BASIC
FUNCTION _b_TbrowDb(p1, p2, p3, p4, p5, p6, p7, p8, p9) as usual
    _Rt_Error(DEVWARNING, "TBrowseDB() is not available in basic mode")
    return NIL
#endif

#ifndef FSIO_BASIC
   local ii, fieldc, col as usual

* fieldc = fcount()
* if fieldc < 1
*    return(NIL)
* endif

   obj:gobottomblock := { |oTbr| dbgobottom() }
   obj:gotopblock    := { |oTbr| dbgotop() }
   obj:skipblock     := { |num,oTbr| __tbroskip(num) }
   obj:Handler       := { |oTbr| TbrDbHandler(oTbr) }

* for ii = 1 to fieldc
*   col := tbcolumnnew(fieldname(ii), fieldblock(fieldname(ii)))
*   obj:addcolumn(col)
* next

return(obj)
#endif


*****************************************************************************
* Function __tbroskip                 The Skipblock of tbrowsenew() objects *
*                                     Actually the same as dbskip, but will *
*                                     not position onto eof.                *
* In : p1 (N) Number of Records to skip                                     *
* Out: fn (N) Number of Records really skipped                              *
*****************************************************************************
STATIC FUNCTION __tbroskip(toskip)
// local iOldRec := recno()      as intvar
local retVal                     as intVar
local iSkipped := dbskip(toskip) as intVar
if !eof()
   retVal := iSkipped
else
   skip -1
   retVal := iSkipped - 1
endif
return retVal
* EOF browsedb.prg *
