/* FS2demo: Demo/Testprogram for FS2 - Toolbox             
 *
 * For FlagShip 5 and 6
 * Copyright (c) 2003..07 by multisoft GmbH, Munich, Germany 
 *
 * You may freely modify this source according to your needs and/or
 * re-use any parts of it in your source code.
 * Release $Date: 2007/06/26 13:47:14 $
 *
 * Compile by "make" (or "nmake" with MS-VC6)
 */

parameters par1

#include "fspreset.fh"
set font "courier"

? "This application is compiled with " 
if left(AppCompiled(),1) == "A"
   ?? "-io=a switch for hybrid mode"
elseif left(AppCompiled(),1) == "G"
   ?? "-io=g switch for GUI mode"
elseif left(AppCompiled(),1) == "T"
   ?? "-io=t switch for Terminal i/o mode"
elseif left(AppCompiled(),1) == "B"
   ?? "-io=b switch for Basic i/o mode"
else
   ?? "unknown switches"
endif
?   
aText := {"   GUI mode: ", ;
          "   Terminal i/o on X11: ", ;
          "   Terminal i/o on console: "}
iLng := 0
for ii := 1 to len(aText)
   iLng := max(iLng, StrLen2col(aText[ii]))
next          
? "Invoke:"
? aText[1] 
@ row(), iLng SAY execname() + "  -or-  ./" + execname()
? aText[2] 
@ row(), iLng SAY "newfswin " +  execname() + " -io=t"
? aText[3] 
@ row(), iLng SAY "newfscons " +  execname() + " -io=t"
?
   
if !empty(par1)
   wait
   quit
else
   ? "Help: " + execname() + " -h"
   ?
   sleep (3)
   cls
endif

/* Initialising
 */
std_color  = "W/B"
enh_color  = "R+/B"
menu_color = if (iscolor(), "GR+/B,B/W,B,B,W/B", "W/N,N/W")

set function 40 to chr(27) + chr(27) + chr(27)  && ALT-F10 == exit from Program

setcolor(menu_color)
@ 0,0 clear
@ 2,2,4,78 box " "
setcolor(enh_color)
@ 3,10 say "FS2 FlagShip Toolbox Demo, (c) " + ltrim(year(date())) + " by multisoft "
setcolor(std_color)

/* Test for FlagShip 
 */
* public Clipper, FlagShip
* if FlagShip
*    FS_SET("LoadLanguage",1,"FSsorttab.ger")   && German sort tab
*    FS_SET("SetLanguage",1)
* endif

/* Chapter
 */
private chap_arrl[14], chap_arr[14]

chap_arr[ 1] = "Window functions"
chap_arr[ 2] = "String functions"
chap_arr[ 3] = "Stringtoken funct"
chap_arr[ 4] = "Bit manipulation"
chap_arr[ 5] = "Video"
chap_arr[ 6] = "Floppy/Harddisk"
chap_arr[ 7] = "Printer"
chap_arr[ 8] = "Date/Time"
chap_arr[ 9] = "Database info"
chap_arr[10] = "Switches/Status"
chap_arr[11] = "System info"
chap_arr[12] = "Miscelaneous"
chap_arr[13] = "Mathematical fn"
chap_arr[14] = "Get/Read"


afill(chap_arrl, .T.)
chap_arr[ 2] = substr(chap_arr[ 2],1,22) + ' *'
chap_arr[ 3] = substr(chap_arr[ 3],1,22) + ' *'
chap_arr[ 4] = substr(chap_arr[ 4],1,22) + ' *'
chap_arr[ 6] = substr(chap_arr[ 6],1,22) + ' *'
chap_arr[ 8] = substr(chap_arr[ 8],1,22) + ' *'
chap_arr[10] = substr(chap_arr[10],1,22) + ' *'
chap_arr[13] = substr(chap_arr[13],1,22) + ' *'


*************************

private string_arr[63]

string_arr[ 1] = "addascii()"       
string_arr[ 2] = "afteratnum()"    
string_arr[ 3] = "asciisum()"
string_arr[ 4] = "ascpos()"
string_arr[ 5] = "atnum()"
string_arr[ 6] = "numat()"
string_arr[ 7] = "atrepl()"
string_arr[ 8] = "beforatnum()"
string_arr[ 9] = "center()"
string_arr[10] = "charadd()"
string_arr[11] = "charand()"
string_arr[12] = "charor()"
string_arr[13] = "charxor()"
string_arr[14] = "charnot()"
string_arr[15] = "chareven()"
string_arr[16] = "charodd()"
string_arr[17] = "charlist()"
string_arr[18] = "charmirr()"
string_arr[19] = "charmix()"
string_arr[20] = "charone()"
string_arr[21] = "charonly()"
string_arr[22] = "charrela()"
string_arr[23] = "charrelrep()"
string_arr[24] = "charrem()"
string_arr[25] = "charrepl()"
string_arr[26] = "charsort()"
string_arr[27] = "charspread()"
string_arr[28] = "charswap()"
string_arr[29] = "checksum()"
string_arr[30] = "countleft()"
string_arr[31] = "countright()"
string_arr[32] = "csetatmupa()"
string_arr[33] = "expand()"
string_arr[34] = "justleft()"
string_arr[35] = "justright()"
string_arr[36] = "maxline()"
string_arr[37] = "numline()"
string_arr[38] = "padleft()"
string_arr[39] = "padright()"
string_arr[40] = "posalpha()"
string_arr[41] = "posupper()"
string_arr[42] = "poslower()"
string_arr[43] = "posdel()"
string_arr[44] = "posdiff()"
string_arr[45] = "posins()"
string_arr[46] = "posrange()"
string_arr[47] = "posrepl()"
string_arr[48] = "rangerepl()"
string_arr[49] = "remall()"
string_arr[50] = "remleft()"
string_arr[51] = "remright()"
string_arr[52] = "replall()"
string_arr[53] = "replleft()"
string_arr[54] = "replrigth()"
string_arr[55] = "strswap()"
string_arr[56] = "tabexpand()"
string_arr[57] = "tabpack()"
string_arr[58] = "valpos()"
string_arr[59] = "wordone()"
string_arr[60] = "wordonly()"
string_arr[61] = "wordrepl()"
string_arr[62] = "wordtochar()"
string_arr[63] = "wordswap()"

private stoken_arr[8]
stoken_arr[ 1] = "attoken()"
stoken_arr[ 2] = "numtoken()"
stoken_arr[ 3] = "tokenlower()"
stoken_arr[ 4] = "tokenupper()"
stoken_arr[ 5] = "token()"
stoken_arr[ 6] = "tokensep()"
stoken_arr[ 7] = "tokennext()"
stoken_arr[ 8] = "tokeninit()"

private diskfn_arr[16]

diskfn_arr[ 1] = "deletefile()"
diskfn_arr[ 2] = "filedelete()"
diskfn_arr[ 3] = "dirremove()"
diskfn_arr[ 4] = "dirchange()"
diskfn_arr[ 5] = "dirname()"
diskfn_arr[ 6] = "dirmake()"
diskfn_arr[ 7] = "filesize()"
diskfn_arr[ 8] = "filedate()"
diskfn_arr[ 9] = "filetime()"
diskfn_arr[10] = "fileattr()"
diskfn_arr[11] = "fileappend()"
diskfn_arr[12] = "renamefile()"
diskfn_arr[13] = "filecopy()"
diskfn_arr[14] = "filemove()"
diskfn_arr[15] = "fileseek()"
diskfn_arr[16] = "csetsafety()"

private datefn_arr[23]

datefn_arr[ 1] = "addmonth()"      && all date fn except setdate()
datefn_arr[ 2] = "bom()"           &&                    settime()
datefn_arr[ 3] = "boq()"           &&                    showtime()
datefn_arr[ 4] = "boy()"
datefn_arr[ 5] = "eom()"
datefn_arr[ 6] = "eoq()"
datefn_arr[ 7] = "eoy()"
datefn_arr[ 8] = "ctodow()"
datefn_arr[ 9] = "ctomonth()"
datefn_arr[10] = "mdy()"
datefn_arr[11] = "dmy()"
datefn_arr[12] = "isleap()"
datefn_arr[13] = "lastdayom()"
datefn_arr[14] = "ntocdow()"
datefn_arr[15] = "ntocmonth()"
datefn_arr[16] = "quarter()"
datefn_arr[17] = "sectotime()"
datefn_arr[18] = "stod()"
datefn_arr[19] = "timetosec()"
datefn_arr[20] = "timevalid()"
datefn_arr[21] = "waitperiod()"
datefn_arr[22] = "week()"
datefn_arr[23] = "wom()"


private mathem_arr[23]

mathem_arr[ 1] = "acos()"
mathem_arr[ 2] = "asin()"
mathem_arr[ 3] = "atan()"
mathem_arr[ 4] = "atn2()"
mathem_arr[ 5] = "ceiling()"
mathem_arr[ 6] = "cos()"
mathem_arr[ 7] = "cot()"
mathem_arr[ 8] = "dtor()"
mathem_arr[ 9] = "fact()"
mathem_arr[10] = "floor()"
mathem_arr[11] = "fv()"
mathem_arr[12] = "getprc()"
mathem_arr[13] = "log10()"
mathem_arr[14] = "payments()"
mathem_arr[15] = "periods()"
mathem_arr[16] = "pi()"
mathem_arr[17] = "pv()"
mathem_arr[18] = "rate()"
mathem_arr[19] = "rtod()"
mathem_arr[20] = "setprec()"
mathem_arr[21] = "sign()"
mathem_arr[22] = "sin()"
mathem_arr[23] = "tan()"

private set_arr[35]
set_arr[ 1] = "csetall()"
set_arr[ 2] = "csetalte()"
set_arr[ 3] = "csetbell()"
set_arr[ 4] = "csetcarr()"
set_arr[ 5] = "csetcent()"
set_arr[ 6] = "csetconf()"
set_arr[ 7] = "csetcons()"
set_arr[ 8] = "csetcurs()"
set_arr[ 9] = "csetdele()"
set_arr[10] = "csetdeli()"
set_arr[11] = "csetdevi()"
set_arr[12] = "csetesca()"
set_arr[13] = "csetexac()"
set_arr[14] = "csetexcl()"
set_arr[15] = "csetfixe()"
set_arr[16] = "csetinte()"
set_arr[17] = "csetprin()"
set_arr[18] = "csetscor()"
set_arr[19] = "csetsoft()"
set_arr[20] = "csetuniq()"
set_arr[21] = "csetwrap()"
set_arr[22] = "csetclip()"
set_arr[23] = "csetdate()"
set_arr[24] = "csetdeci()"
set_arr[25] = "csetmarg()"
set_arr[26] = "csetldel()"
set_arr[27] = "csetrdel()"
set_arr[28] = "csetdefa()"
set_arr[29] = "csetpath()"
set_arr[30] = "csetfunc()"
set_arr[31] = "csetkey()"
set_arr[32] = "csetrdonly()"
set_arr[33] = "csetsnow()"
set_arr[34] = "isdebug()"
set_arr[35] = "setlastkey()"

private bit_arr[26]
bit_arr[ 1] = "bittoc()"
bit_arr[ 2] = "ctobit()"
bit_arr[ 3] = "celsius()"
bit_arr[ 4] = "fahrenheit()"
bit_arr[ 5] = "ctof()"
bit_arr[ 6] = "ftoc()"
bit_arr[ 7] = "cton()"
bit_arr[ 8] = "ntoc()"
bit_arr[ 9] = "exponent()"
bit_arr[10] = "mantissa()"
bit_arr[11] = "infinity()"
bit_arr[12] = "intneg()"
bit_arr[13] = "intpos()"
bit_arr[14] = "isbit()"
bit_arr[15] = "setbit()"
bit_arr[16] = "lton()"
bit_arr[17] = "numcount()"
bit_arr[18] = "numand()"
bit_arr[19] = "numor()"
bit_arr[20] = "numnot()"
bit_arr[21] = "numhigh()"
bit_arr[22] = "numlow()"
bit_arr[23] = "numxor()"
bit_arr[24] = "numrol()"
bit_arr[25] = "rand()"
bit_arr[26] = "random()"

*************************
do while .T.
   mainwahl = centmenu(24, "Choose the FS2 group",  chap_arr, chap_arrl)
   if lastkey() = 27
exit
   endif
   wahl = 1
   do case
   case mainwahl = 1
	  save screen
	  clear screen
      do windemo
	  restore screen
loop
   case mainwahl = 2
      do while wahl != 0
         wahl = centmenu(22, chap_arr[mainwahl], string_arr)
         do demo_str with wahl
      enddo
loop
   case mainwahl = 3
      do while wahl != 0
         wahl = centmenu(22, chap_arr[mainwahl], stoken_arr)
         do demo_stk with wahl
      enddo
loop
   case mainwahl = 4
      do while wahl != 0
         wahl = centmenu(22, chap_arr[mainwahl], bit_arr)
         do demo_bit with wahl
      enddo
loop
   case mainwahl = 6
      do while wahl != 0
         wahl = centmenu(22, chap_arr[mainwahl], diskfn_arr)
         do demo_dsk with wahl
      enddo
   case mainwahl = 8
      do while wahl != 0
         wahl = centmenu(22, chap_arr[mainwahl], datefn_arr)
         do demo_dat with wahl
      enddo
   case mainwahl = 10
      do while wahl != 0
         wahl = centmenu(22, chap_arr[mainwahl], set_arr)
         do demo_set with wahl
      enddo
   case mainwahl = 13
      do while wahl != 0
         wahl = centmenu(22, chap_arr[mainwahl], mathem_arr)
         do demo_mat with wahl
      enddo
loop
   otherwise
      do default_act with mainwahl
   endcase
enddo
set color to
@ 0,0 clear

return

/****************************************************************************
 * centmenu Achoice menu: center and display for lines 5-24           
 * P1 : Header                                                        
 * p2 : menu-array                                                    
 * p3 : logic-array (when not given, the choice remains actuel)       
 */
function centmenu
parameters breite, headertext, menu1, menu2
private oben, links, unten, rechts

breite = breite + 4

links = (80 - breite) / 2
rechts = links + breite
oben = 5
unten = 24
if (unten - oben) - 4 > len(menu1)
   oben = 6
   unten = oben + 3 + len(menu1)
endif
if AppIoMode() == "G"
   oben := 5
   unten := min(maxrow(), oben + 3 + len(menu1))
   links := 10
   rechts := links + breite
endif
   
if pcount() = 4 && (type("menu2")) = "A"
   ret = saymenu(oben, links, unten, rechts, headertext, menu1, menu2)
else
   ret = saymenu(oben, links, unten, rechts, headertext, menu1)
endif

return(ret)

/****************************************************************************
 * saymenu display with achoice            
 * P1..p4 : coordinates of the border      
 * P5 : header                             
 * p6 : menu-array                         
 * p7 : logic-array                        
 */
function saymenu
parameters oben, links, unten, rechts, headertext, menu1, menu2

private buffer, ret
public saymenuret
if type("saymenuret") != "N"
   saymenuret = 1
endif

setcolor(menu_color)
buffer = savescreen(oben, links, unten, rechts)
if AppIoMode() != "G"
   @ oben, links, unten, rechts box " "
   @ oben + 2, links say "" + replicate("", rechts - (links + 1)) + ""
endif
setcolor(enh_color)
@ oben + 1, links + 2 say headertext
setcolor(menu_color)

set key 19 to say_cursup                          && cursor left
set key 4  to say_cursdn                          && cursor right

if pcount () = 7                                 && (type("menu2")) = "A"
   saymenuret = 1
   ret = achoice(oben + 3 , links + 2, unten - 1, rechts - 2, menu1, menu2)
else
   if saymenuret > len(menu1)                    && illegal valuie
      saymenuret = 1
   endif
   ret = achoice(oben + 3 , links + 2, unten - 1, rechts - 2, menu1,.t., ;
                 .t.,saymenuret)
   saymenuret = ret
endif
restscreen(oben, links, unten, rechts, buffer)
setcolor(std_color)
return(ret)

/****************************************************************************
 * helpers
 */
procedure say_cursup
parameters p1, p2, p3
keyboard(chr(5))
return

****************************************************************************
procedure say_cursdn
parameters p1, p2, p3
keyboard(chr(24))
return

****************************************************************************
procedure demo_dsk
parameters p1
@ 15, 10 say "Sorry, demo for disk access not available"
?? chr(7)
inkey(10)
@ 15, 10 clear
return

****************************************************************************
procedure default_act
parameters p1
@ 15, 10 say "Demo/Test functions for " + chap_arr[p1] + " not available"
?? chr(7)
inkey(10)
@ 15, 10 clear
return

****************************************************************************
procedure def_infunct
parameters p1
@ 15, 20 say "Demo for function " + p1 + " not available"
?? chr(7)
inkey(10)
@ 15, 20 clear
return

****************************************************************************
procedure ende_wait

@ 23,0 say "Press any key to continue"
inkey(30)
@ 5,0 clear
return
