* Test PC8 output 
* Compile in Linux                   : FlagShip pc8test.prg -o pc8test 
* Execute in Linux in GUI mode       : ./pc8test         
* Execute in Linux in Terminal mode  : newfswin ./pc8test         
* Test on console command-line       : newfswin ; cat pc8test.txt
*
* Compile in Windows                 : FlagShip pc8test.prg 
* Execute in Windows in GUI mode     : pc8test         
* Execute in Windows in Terminal mode: pc8test -io=t       
* Test on console command-line       : type pc8test.txt
*
* When you wish to use font for CodePage 437, 850, 852 etc, set
* in Linux:   export FSCODEPAGE=CP852    etc.
* in Windows: set FSCODEPAGE=CP852       etc. 

#ifdef FlagShip
   set font "courier", 12
   
   SET GUITRANSL ASCII    ON
   SET GUITRANSL LINES    ON
   SET GUITRANSL BOX      ON
   SET GUITRANSL TEXTDRAW ON

   if AppIoMode() == "T"                  // Terminal i/o mode?
      codepage := getenv("FSCODEPAGE")    // CP437, CP850 etc.
# ifdef FS_WIN32   /* Windows */
      if empty(codepage)
         codepage := "default"
      else
         iCP := val(codepage)
         if iCP == 0 .and. upper(left(codepage,2)) == "CP"
            iCp := val(substr(codepage,3))
         endif
         if iCP > 100 .and. iCP < 1000
            run ("mode con cp select=" + ltrim(iCP))
         else
            codepage += " - unsupported"
         endif
      endif
# else             /* Unix/Linux */
      if empty(codepage) .or. left(codepage,2) != "CP"   
         codepage := "multisoft"
      else
         FS_SET("outmap", "FSchrmap.def", codepage)   // use CPnnn mapping
      endif   
# endif
      ? "Using CodePage/font:", codepage
      
   elseif AppIoMode() == "B"      // Basic mode?
      ? "The display will use default font w/o mapping"
   endif
#else    /* Clipper */
   cls
#endif   /* FlagShip */

if !file("pc8test.txt")
   createFile("pc8test.txt")  // print chr(1..255) to file
endif

displayCharset()              // display chr(1..255) on screen
wait

*********************************************************************
FUNCTION displayCharset()
local ii, rr := row()+1, cc := 8
for ii := 1 to 127
   if ii % 10 == 0
      rr++
      cc := 0
   endif
   @ rr, cc say strzero(ii,3) + ": " + chr(ii)
   cc := col() +2
next
rr++
cc := 64

if (rr + 12) > maxrow() 
   wait
   cls
   rr := 1
endif
for ii := 128 to 255
   if ii % 10 == 0
      rr++
      cc := 0
   endif
   if ii > 130 .and. ii < 160
      @ rr, cc    // avoid corrupted output by incorrect font
   endif
   @ rr, cc say strzero(ii,3) + ": " + chr(ii)
   cc := col() +2
   inkey()        // some sequences triggers ESC
next
return

*********************************************************************
FUNCTION createFile(cName)
local ii
set print to (cName)
set console off
set print on

for ii := 1 to 255
   if ii % 10 == 1
      ? str(ii,3)+"-"+str(min(ii+9,255),3)+": "
   endif
   if ii == 9 .or. ii == 10 .or. ii == 13    // would corrupt output
      ?? str(ii,3)+":  "
#ifdef FS_WIN32
   elseif ii == 26         // chr(26) = ^Z would terminate print via "type ..."
      ?? str(ii,3)+":  "
#endif   
   else
      ?? str(ii,3)+":"+chr(ii) + " "
   endif
next
?
? "Umlauts aA uU oO ss = " + ;
   chr(132)+chr(142)+" " + ;
   chr(129)+chr(154)+" " + ;
   chr(148)+chr(153)+" " + chr(225)
? "semi-graphic " + chr(195)+chr(196)+chr(197)+chr(196)+chr(180) + " " + ;
                    chr(199)+chr(196)+chr(215)+chr(196)+chr(182) + " " + ;
                    chr(204)+chr(205)+chr(206)+chr(205)+chr(185)
?
set console on
set print off

? "File", cName, "created."
? "You may test the console environment by entering"
#ifdef FlagShip
# ifdef FS_WIN32
? "   type pc8test.txt"
# else
? "   cat pc8test.txt"
# endif
#else
? "   type pc8test.txt"
#endif   
? "at command line."
wait
cls
return

** eof
